///////////////////
//  This function returns a string that is the name of the keg, dependant on the type of Potion inside it
//////////////////

function get_keg_name(Potion_objtype, Potion_subtype)
	var the_string := 0;
	case (Potion_objtype)
		0xdc01:		the_string := "Keg of Light Healing Potions";
		0xdc02:		the_string := "Keg of Healing Potions";
		0xdc03:		the_string := "Keg of Greater Healing Potions";
		0xdc04:		the_string := "Keg of Lesser Poison Potions";
		0xdc05:		the_string := "Keg of Poison Potions";
		0xdc06:		the_string := "Keg of Greater Poison Potions";
		0xdc07:		the_string := "Keg of Greater Explosion Potions";
		0xdc08:		the_string := "Keg of Lesser Explosion Potions";
		0xdc09:		the_string := "Keg of Explosion Potions";
		0xdc0b:		the_string := "Keg of Lesser Agility Potions";
		0xdc0c:		the_string := "Keg of Agility Potions";
		0xdc0d:		the_string := "Keg of Greater Agility Potions";
		0xdc0e:		the_string := "Keg of Refresh Potions";
		0xdc0f:		the_string := "Keg of Greater Refresh Potions";
		0xdc10:		the_string := "Keg of Lesser Strength Potions";
		0xdc11:		the_string := "Keg of Strength Potions";
		0xdc12:		the_string := "Keg of Greater Strength Potions";
		0xdc14:		the_string := "Keg of Lesser Cure Potions";
		0xdc15:		the_string := "Keg of Cure Potions";
		0xdc16:		the_string := "Keg of Greater Cure Potions";
		0xdc17:		the_string := "Keg of Deadly Poison Potions";
		0xdce6:		the_string := "Keg of Nightsight Potions";
		0x7059:
			case (Potion_subtype)
				23:	the_string := "Keg of Invisibility Potions";
				24:	the_string := "Keg of Phandel's Fine Intellect Potions";
				25:	the_string := "Keg of Phandel's Fabulous Intellect Potions";
				26:	the_string := "Keg of Phandel's Fantastic Intellect Potions";
				27:	the_string := "Keg of Lesser Mego Invulnerability Potions";
				28:	the_string := "Keg of Mego Invulnerability Potions";
				29:	the_string := "Keg of Greater Mego Invulnerability Potions";
				30:	the_string := "Keg of Grand Mage Refresh Elixir";
				31:	the_string := "Keg of Homeric Might Potions";
				32:	the_string := "Keg of Greater Homeric Might Potions";
				33:	the_string := "Keg of Tamla Heal Potions";
				34:	the_string := "Keg of Taint's Minor Transmutation Potions";
				35:	the_string := "Keg of Taint's Major Transmutation Potions";
			endcase
	endcase

	return the_string;
endfunction




///////////////////
//  This function returns a string that is the name of the Potion
//////////////////

function get_Potion_name(Potion_objtype, Potion_subtype)
	var the_string := 0;
	case (Potion_objtype)
		0xdc01:		the_string := "Light Healing Potion";
		0xdc02:		the_string := "Healing Potion";
		0xdc03:		the_string := "Greater Healing Potion";
		0xdc04:		the_string := "Lesser Poison Potion";
		0xdc05:		the_string := "Poison Potion";
		0xdc06:		the_string := "Greater Poison Potion";
		0xdc07:		the_string := "Greater Explosion Potion";
		0xdc08:		the_string := "Lesser Explosion Potion";
		0xdc09:		the_string := "Explosion Potion";
		0xdc0b:		the_string := "Lesser Agility Potion";
		0xdc0c:		the_string := "Agility Potion";
		0xdc0d:		the_string := "Greater Agility Potion";
		0xdc0e:		the_string := "Refresh Potion";
		0xdc0f:		the_string := "Greater Refresh Potion";
		0xdc10:		the_string := "Lesser Strength Potion";
		0xdc11:		the_string := "Strength Potion";
		0xdc12:		the_string := "Greater Strength Potion";
		0xdc14:		the_string := "Lesser Cure Potion";
		0xdc15:		the_string := "Cure Potion";
		0xdc16:		the_string := "Greater Cure Potion";
		0xdc17:		the_string := "Deadly Poison Potion";
		0xdce6:		the_string := "Nightsight Potion";
		0x7059:
			case (Potion_subtype)
				23:	the_string := "Invisibility Potion";
				24:	the_string := "Phandel's Fine Intellect";
				25:	the_string := "Phandel's Fabulous Intellect";
				26:	the_string := "Phandel's Fantastic Intellect";
				27:	the_string := "Lesser Mego Invulnerability Potion";
				28:	the_string := "Mego Invulnerability Potion";
				29:	the_string := "Greater Mego Invulnerability Potion";
				30:	the_string := "Grand Mage Refresh Elixir";
				31:	the_string := "Homeric Might Potion";
				32:	the_string := "Greater Homeric Might Potion";
				33:	the_string := "Tamla Heal Potion";
				34:	the_string := "Taint's Minor Transmutation";
				35:	the_string := "Taint's Major Transmutation";
			endcase
	endcase

	return the_string;
endfunction




///////////////////
//  This function returns a dictionary of all reagents used in alchemy relating them to their names.
//  its used in the Potionbook script to translate names
///////////////////

function define_reagent_name_dictionary()
	var reagent := dictionary;

	//normal reagents
	reagent [ 0x0f78 ]		:= "bat wing";
	reagent [ 0x0f79 ]		:= "blackmoor";
	reagent [ 0x0f7a ]		:= "black pearl";
	reagent [ 0x0f7b ]		:= "blood moss";
	reagent [ 0x0f7c ]		:= "blood spawn";
	reagent [ 0x0f7d ]		:= "vial of blood";
	reagent [ 0x0f7e ]		:= "bone";
	reagent [ 0x0f7f ]		:= "brimstome";
	reagent [ 0x0f80 ]		:= "deamon bone";
	reagent [ 0x0f81 ]		:= "fertile dirt";
	reagent [ 0x0f82 ]		:= "dragon's blood";
	reagent [ 0x0f83 ]		:= "executioner's cap";
	reagent [ 0x0f84 ]		:= "garlic";
	reagent [ 0x0f85 ]		:= "ginseng";
	reagent [ 0x0f86 ]		:= "mandrake root";
	reagent [ 0x0f87 ]		:= "eye of newt";
	reagent [ 0x0f88 ]		:= "nightshade";
	reagent [ 0x0f89 ]		:= "obsidian";
	reagent [ 0x0f8a ]		:= "pig iron";
	reagent [ 0x0f8b ]		:= "pumice";
	reagent [ 0x0f8c ]		:= "sulfurous ash";
	reagent [ 0x0f8d ]		:= "spider's silk";
	reagent [ 0x0f8e ]		:= "serpent scale";
	reagent [ 0x0f8f ]		:= "volcanic ash";
	reagent [ 0x0f90 ]		:= "dead wood";
	reagent [ 0x0f91 ]		:= "wyrm's heart";

	//other Potions
	reagent [ 0xdc01 ]		:= "l. heal potion";
	reagent [ 0xdc02 ]		:= "heal potion";
	reagent [ 0xdc03 ]		:= "gr. heal potion";
	reagent [ 0xdc04 ]		:= "l. poison potion";
	reagent [ 0xdc05 ]		:= "poison potion";
	reagent [ 0xdc06 ]		:= "gr. poison potion";
	reagent [ 0xdc07 ]		:= "gr. explosion pot.";
	reagent [ 0xdc08 ]		:= "l. explosion pot.";
	reagent [ 0xdc09 ]		:= "exposion potion";
	reagent [ 0xdc0b ]		:= "l. agility potion";
	reagent [ 0xdc0c ]		:= "agility potion";
	reagent [ 0xdc0d ]		:= "gr. agility pot.";
	reagent [ 0xdc0e ]		:= "refresh potion";
	reagent [ 0xdc0f ]		:= "full refresh pot.";
	reagent [ 0xdc10 ]		:= "l. strength pot.";
	reagent [ 0xdc11 ]		:= "strength potion";
	reagent [ 0xdc12 ]		:= "gr. strength pot.";
	reagent [ 0xdc14 ]		:= "l. cure potion";
	reagent [ 0xdc15 ]		:= "cure potion";
	reagent [ 0xdc16 ]		:= "gr. cure potion";
	reagent [ 0xdc17 ]		:= "deadly poison pot.";
	reagent [ 0xdce6 ]		:= "nightsight potion";

	//gems
	reagent [ 0x0f0f ]		:= "star sapphire";
	reagent [ 0x0f10 ]		:= "emerald";
	reagent [ 0x0f11 ]		:= "sapphire";
	reagent [ 0x0f12 ]		:= "sapphire";
	reagent [ 0x0f13 ]		:= "ruby";
	reagent [ 0x0f14 ]		:= "ruby";
	reagent [ 0x0f15 ]		:= "citrine";
	reagent [ 0x0f16 ]		:= "amethyst";
	reagent [ 0x0f17 ]		:= "amethyst";
	reagent [ 0x0f18 ]		:= "tourmaline";
	reagent [ 0x0f19 ]		:= "sapphire";
	reagent [ 0x0f1a ]		:= "ruby";
	reagent [ 0x0f1b ]		:= "star sapphire";
	reagent [ 0x0f1c ]		:= "ruby";
	reagent [ 0x0f1d ]		:= "ruby";
	reagent [ 0x0f1e ]		:= "tourmaline";
	reagent [ 0x0f1f ]		:= "sapphire";
	reagent [ 0x0f20 ]		:= "tourmaline";
	reagent [ 0x0f21 ]		:= "star sapphire";
	reagent [ 0x0f22 ]		:= "amethyst";
	reagent [ 0x0f23 ]		:= "citrine";
	reagent [ 0x0f24 ]		:= "citrine";
	reagent [ 0x0f25 ]		:= "amber";
	reagent [ 0x0f26 ]		:= "diamond";
	reagent [ 0x0f27 ]		:= "diamond";
	reagent [ 0x0f28 ]		:= "diamond";
	reagent [ 0x0f29 ]		:= "diamond";
	reagent [ 0x0f2a ]		:= "ruby";
	reagent [ 0x0f2b ]		:= "ruby";
	reagent [ 0x0f2c ]		:= "citrine";
	reagent [ 0x0f2d ]		:= "tourmaline";
	reagent [ 0x0f2e ]		:= "amethyst";
	reagent [ 0x0f2f ]		:= "emerald";
	reagent [ 0x0f30 ]		:= "diamond";

	//other stuff
	reagent [ 0x0f0e ]		:= "empty bottle";
	reagent [ 0x7022 ]		:= "troll hide";

	return reagent;
endfunction
