// AutoLoop.inc by Lapo 'Aspox' Luchini <lapo@lapo.it>

/*
** AutoLoop_init asks character how many time it wants to iterate
** [if "autoloop" CProp is set it doesn't ask but uses that value, unless is 0]
** AutoLoop_more retunrs the number of loops remaining
**
** Use like this (for a crafter-like skill):
**
** AutoLoop_init(who);
** while(AutoLoop_more()>0 && <material_not_finished>)
**   <create_item>;
** endwhile
** AutoLoop_finish();
*/
use uo;
Use os;
Use basic;
include "include/client";

const AL_consecutive := 9999;
const AL_timeout := 9999;

var AL_number	:= 0;
var AL_remain	:= 0;
var AL_char;
var AL_delay;
var AL_charX;
var AL_charY;
var AL_setting;

function AutoLoop_init( character, maxx := 60000, delay := 0 )

	AL_setting := CInt( GetObjProperty( character, "autoloop" ) );
	if( !AL_setting )
		SetObjProperty ( character, "autoloop", 0 );
		AL_setting := 0;
	endif

	if( AL_setting == 0 )
		AL_number := CInt( SendTextEntryGump(character, "How many loops? [0-"+maxx+"]", TE_CANCEL_ENABLE, TE_STYLE_NORMAL, 4));
	else
		AL_number := AL_setting;
	endif

	if( !AL_number )
		AL_number := 0;
	elseif( AL_number > maxx )
		AL_number := maxx;
	endif

	AL_remain := AL_number;
	AL_char   := character;
	AL_charX  := AL_char.x;
	AL_charY  := AL_char.y;
	AL_delay  := delay;

endfunction

function AutoLoop_more()

	if( (AL_charX == AL_char.x) && (AL_charY == AL_char.y) )
		if( AL_remain > 0 )
			if( AL_remain != AL_number )
				Sleep( AL_delay );
				if( (AL_number - AL_remain) % AL_consecutive == 0)
				endif
			endif
			if( AL_remain > 0 )
				SendSysMessage( AL_char , "Looping [" + AL_remain + " more to go].", 3 , 2611 );
				AL_remain := CInt( AL_remain ) - 1;
			endif
		else
			AL_remain := -1;
		endif
	else
		SendSysMessage( AL_char , "You moved." , 3 , 2595 );
		AL_remain := -1;
		AL_number := 0; // to print "looping aborted"
	endif

	return( AL_remain+1 );

endfunction

function AutoLoop_finish()

	if( (AL_remain < 0) && AL_number )
		SendSysMessage( AL_char, "You finished looping.", 3, 2611);
	else
		SendSysMessage( AL_char, "Looping aborted.", 3, 2595);
	endif

	AL_number := 0;
	AL_remain := 0;

endfunction
