/*
   Author: Unreal (MontuZ@Gmail.com) Jan 29, 2006.
   Version: 0.9
   Core: 095
   Bugs: None. Atleast none that I know of..
   PS: You know it was done by me when it's so clean.
*/

Use cfgfile;

Include "include/gumps";

// Order Races
//Const CITYID_GANDLATHAR  := "Gandlathar";
//Const COORDID_GANDLATHAR := { MinX, MinY, MaxX, MaxY };

Const FACTID_ORDER     := "Order";
Const RACEID_HUMAN   := "Human";
Const RACEID_DWARVE  := "Dwarve";
Const RACEID_GNOME   := "Gnome";

// Chaos Races
//Const CITYID_YORKSHIRE   := "Yorkshire";
//Const COORDID_YORKSHIRE  := { MinX, MinY, MaxX, MaxY };

Const FACTID_CHAOS    := "Chaos";
Const RACEID_DAEMON   := "Daemon";
Const RACEID_VAMPIRE  := "Vampire";
Const RACEID_DARKELVE := "Dark-Elve";

// Neutral Races
//Const CITYID_IRONVALE    := "Ironvale";
//Const COORDID_IRONVALE   := { MinX, MinY, MaxX, MaxY };

Const FACTID_NEUTRAL := "Neutral";
Const RACEID_TROLL     := "Troll";
Const RACEID_ORC       := "Orc";
Const RACEID_NIGHTELVE := "Night-Elve";

Function FixRaceColor( Who )

    Var PlayerRace := Who.title_race;
    
    If( !PlayerRace )
    Return Error;
    Endif
    
    Var Color := 0;
    
    Case( PlayerRace )
    RACEID_TROLL:     Color := 800;
    RACEID_ORC:       Color := 33885;
    RACEID_NIGHTELVE: Color := 33870;
    RACEID_DAEMON:    Color := 33;
    RACEID_VAMPIRE:   Color := 2480;
    RACEID_DARKELVE:  Color := 33875;
    RACEID_HUMAN:     Color := 1002;
    RACEID_DWARVE:    Color := 33880;
    RACEID_GNOME:     Color := 777;
    default:          Color := Who.truecolor;
    Endcase
    
    If( Color )
    Who.color := Color;
    Who.truecolor := Color;
    Endif


Endfunction

Function GetFactionByRace( Who )

    Var PlayerRace := Who.title_race;
    If( !PlayerRace )
    PlayerRace := "";
    Endif

    Case( PlayerRace )
    RACEID_TROLL:     Return FACTID_NEUTRAL;
    RACEID_ORC:       Return FACTID_NEUTRAL;
    RACEID_NIGHTELVE: Return FACTID_NEUTRAL;
    RACEID_DAEMON:    Return FACTID_CHAOS;
    RACEID_VAMPIRE:   Return FACTID_CHAOS;
    RACEID_DARKELVE:  Return FACTID_CHAOS;
    RACEID_HUMAN:     Return FACTID_ORDER;
    RACEID_DWARVE:    Return FACTID_ORDER;
    RACEID_GNOME:     Return FACTID_ORDER;
    Default:          Return Error;
    Endcase

Endfunction

Function GetFactionByRaceDep( Race )

    Case( Race )
    RACEID_TROLL:     Return FACTID_NEUTRAL;
    RACEID_ORC:       Return FACTID_NEUTRAL;
    RACEID_NIGHTELVE: Return FACTID_NEUTRAL;
    RACEID_DAEMON:    Return FACTID_CHAOS;
    RACEID_VAMPIRE:   Return FACTID_CHAOS;
    RACEID_DARKELVE:  Return FACTID_CHAOS;
    RACEID_HUMAN:     Return FACTID_ORDER;
    RACEID_DWARVE:    Return FACTID_ORDER;
    RACEID_GNOME:     Return FACTID_ORDER;
    Default:          Return Error;
    Endcase

Endfunction

Function GetFaction( Who )

    Var Faction := GetObjProperty( Who, "FactionID" );
    If( Faction )
    Return Faction;
    Else
    Faction := GetFactionByRace( Who );
    If( Faction == Error )
    Return Error;
    Endif
    SetObjProperty( Who, "FactionID", Faction );
    Return Faction;
    Endif

Endfunction

Const HIGHLIGHT_COLOR_NEUTRAL := 2634;
Const HIGHLIGHT_COLOR_ENEMY   := 2576;
Const HIGHLIGHT_COLOR_FRIEND  := 2577;
Const HIGHLIGHT_COLOR_STAFF   := 1181;  // 1181

Function GetFactionNameColor( Who, Other )

    Var NPC_Cfg := ReadConfigFile( ":*:npcdesc" );

    If( Other.IsA( POLCLASS_NPC ) )
      If( NPC_Cfg[Other.npctemplate].hostile == 1 && Other.script != "tamed" )
      Return HIGHLIGHT_COLOR_ENEMY;
      Endif
      If( xLegal_NPC( Other ) && !GetFaction( Other ) && Other.script != "tamed" )
      Return HIGHLIGHT_COLOR_NEUTRAL;
      Endif
      If( Other.script == "tamed" && SystemFindObjectBySerial( GetObjProperty( Other, "master" ) ) == Who )
      Return HIGHLIGHT_COLOR_FRIEND;
      Endif
    Endif

    If( Other.CmdLevel )
    Return HIGHLIGHT_COLOR_STAFF;
    Endif

    Var WhoFaction := GetFaction( Who );
    Var OtherFaction := GetFaction( Other );
    
    Case( WhoFaction )
    FACTID_CHAOS:
    Case( OtherFaction )
    FACTID_CHAOS:   Return HIGHLIGHT_COLOR_FRIEND;
    FACTID_ORDER:   Return HIGHLIGHT_COLOR_ENEMY;
    FACTID_NEUTRAL: Return HIGHLIGHT_COLOR_ENEMY;
    Endcase
    
    FACTID_ORDER:
    Case( OtherFaction )
    FACTID_ORDER:   Return HIGHLIGHT_COLOR_FRIEND;
    FACTID_CHAOS:   Return HIGHLIGHT_COLOR_ENEMY;
    FACTID_NEUTRAL: Return HIGHLIGHT_COLOR_ENEMY;
    Endcase
    
    FACTID_NEUTRAL:
    Case( OtherFaction )
    FACTID_NEUTRAL: Return HIGHLIGHT_COLOR_FRIEND;
    FACTID_CHAOS:   Return HIGHLIGHT_COLOR_ENEMY;
    FACTID_ORDER:   Return HIGHLIGHT_COLOR_ENEMY;
    Endcase
    
    Endcase

    Return HIGHLIGHT_COLOR_ENEMY;

Endfunction

Function xLegal_NPC( NPC )

     Var xScript := NPC.script;

     Case( xScript )
     "merchant":      Return 1;
     "banker":        Return 1;
     "animaltrainer": Return 1;
     "animal":        Return 1;
     "barker":        Return 1;
     "barber":        Return 1;
     "healer":        Return 1;
     "sheep":         Return 1;
     "cat":           Return 1;
     "dog":           Return 1;
     "chicken":       Return 1;
     "crier":         Return 1;
     "critterhealer": Return 1;
     "daves_healer":  Return 1;
     "gambler":       Return 1;
     "helppcs":       Return 1;
     "highpriest":     Return 1;
     "lotteryman":     Return 1;
     "performer":      Return 1;
     "playermerchant": Return 1;
     "smartcrier":     Return 1;
     "titlemaster1":   Return 1;
     "townperson":     Return 1;
     "vendor":         Return 1;
     Default:          Return 0;
     Endcase

Endfunction

Function IsOpposingFaction( Who, Other )

    Var WhoFaction := GetFaction( Who );
    Var OtherFaction := GetFaction( Other );

    Case( WhoFaction )
    FACTID_CHAOS:
    Case( OtherFaction )
    FACTID_CHAOS:   Return 0;
    FACTID_ORDER:   Return 1;
    FACTID_NEUTRAL: Return 1;
    Endcase
    Break;
    FACTID_ORDER:
    Case( OtherFaction )
    FACTID_ORDER:   Return 0;
    FACTID_CHAOS:   Return 1;
    FACTID_NEUTRAL: Return 1;
    Endcase
    Break;
    FACTID_NEUTRAL:
    Case( OtherFaction )
    FACTID_NEUTRAL: Return 0;
    FACTID_CHAOS:   Return 1;
    FACTID_ORDER:   Return 1;
    Endcase
    Break;
    Endcase

    Return 1;

Endfunction

Function SendPlayerToRaceHomeTown( Who )

    Var PlayerRace := Who.title_race;

    If( !PlayerRace )
    Return 0;
    Endif

    Var Location;

    Case( PlayerRace )
    RACEID_TROLL:
    Location := { 3726, 390, 0 };
    RACEID_ORC:
    Location := { 3726, 390, 0 };
    RACEID_NIGHTELVE:
    Location := { 3726, 390, 0 };
    
    RACEID_DAEMON:
    Location := { 2949, 1253, 0 };
    RACEID_VAMPIRE:
    Location := { 2949, 1253, 0 };
    RACEID_DARKELVE:
    Location := { 2949, 1253, 0 };
    
    RACEID_HUMAN:
    Location := { 1948, 2187, 0 };
    RACEID_DWARVE:
    Location := { 1948, 2187, 0 };
    RACEID_GNOME:
    Location := { 1948, 2187, 0 };
    Endcase
    
    If( Location )
    MoveCharacterToLocation( who, Location[1], Location[2], Location[3] );
    Return 1;
    Else
    Return 0;
    Endif

Endfunction

Function RandomRaceByFaction( What, FactionID )

    Case( FactionID )
    FACTID_ORDER:
      Case( RandomInt( 3 ) )
      0:
      What.title_race := RACEID_HUMAN;
      FixRaceColor( What );
      Return 1;
      1:
      What.title_race := RACEID_DWARVE;
      FixRaceColor( What );
      Return 1;
      2:
      What.title_race := RACEID_GNOME;
      FixRaceColor( What );
      Return 1;
      Endcase

    FACTID_CHAOS:
      Case( RandomInt( 3 ) )
      0:
      What.title_race := RACEID_DAEMON;
      FixRaceColor( What );
      Return 1;
      1:
      What.title_race := RACEID_VAMPIRE;
      FixRaceColor( What );
      Return 1;
      2:
      What.title_race := RACEID_DARKELVE;
      FixRaceColor( What );
      Return 1;
      Endcase
    FACTID_NEUTRAL:
      Case( RandomInt( 3 ) )
      0:
      What.title_race := RACEID_TROLL;
      FixRaceColor( What );
      Return 1;
      1:
      What.title_race := RACEID_ORC;
      FixRaceColor( What );
      Return 1;
      2:
      What.title_race := RACEID_NIGHTELVE;
      FixRaceColor( What );
      Return 1;
      Endcase
    Endcase

Endfunction

Function SetFactionColorByRace( Who )

    Var PlayerRace := Who.title_race;

    If( !PlayerRace )
    Return 0;
    Endif

    Var Location, Message;

    Case( PlayerRace )
    RACEID_TROLL:
    Who.SetCriminal( 0 );
    Who.SetMurderer( 0 );
    RACEID_ORC:
    Who.SetCriminal( 0 );
    Who.SetMurderer( 0 );
    RACEID_NIGHTELVE:
    Who.SetCriminal( 0 );
    Who.SetMurderer( 0 );

    RACEID_DAEMON:
    Who.SetMurderer( 1 );
    Who.SetCriminal( 0 );
    RACEID_VAMPIRE:
    Who.SetMurderer( 1 );
    Who.SetCriminal( 0 );
    RACEID_DARKELVE:
    Who.SetMurderer( 1 );
    Who.SetCriminal( 0 );

    RACEID_HUMAN:
    Who.SetCriminal( 1 );
    Who.SetMurderer( 0 );
    RACEID_DWARVE:
    Who.SetCriminal( 1 );
    Who.SetMurderer( 0 );
    RACEID_GNOME:
    Who.SetCriminal( 1 );
    Who.SetMurderer( 0 );
    Endcase

    Return 1;

Endfunction

Function IsOrderFaction( Attacker, Defender )

    Var AttackerRace := Attacker.title_race;
    Var DefenderRace := Defender.title_race;

Endfunction
