/*
   Author: Unreal (MontuZ@Gmail.com) Feb 11, 2006.
   Version: 1.9.75
   Core: 095
   % Complete: 85%
   Bugs: None. Atleast none that I know of..
   PS: You know it was done by me when it's so clean.
*/

Use uo;
Use util;

Include "include/attributes";
Include "include/client";
Include "include/damages";
Include "include/classes";
Include "include/dotempmods";
Include "include/equip_layers";

Var Items_Config := ReadConfigFile( ":combat:itemdesc" );
Var Weapon_Attacker, Weapon_Defender;
Var Weapon_Att_CFGElem, Weapon_Def_CFGElem;
Var SkillID;

Function Attack( Attacker, Defender )

    If( Attacker == Defender )
    ApplyRawDamage( Attacker, ( GetAttribute( Attacker, ATTRIBUTEID_STRENGTH ) / 2 ) + 15 );
    Return 1;
    Endif

    Weapon_Attacker := Attacker.weapon;
    Weapon_Defender := Defender.weapon;

    Weapon_Att_CFGElem := Items_Config[Weapon_Attacker.objtype];
    Weapon_Def_CFGElem := Items_Config[Weapon_Defender.objtype];

    Var Range := Distance( Attacker, Defender );

    Var Max_Range := Weapon_Att_CFGElem.MaxRange;
    If( !Max_Range )
    Max_Range := 1;
    Endif

    Var Min_Range := Weapon_Att_CFGElem.MinRange;
    If( !Min_Range )
    Min_Range := 1;
    Endif

    If( Range > Max_Range )
    SendSysMessage( Attacker, "Your opponent is too far away." );
    Return 1;
    Elseif ( Range < Min_Range )
    SendSysMessage( Attacker, "Your opponent is too close." );
    Return 1;
    Endif

    Var Ammo := Weapon_Att_CFGElem.ProjectileType;
    Var Damage_Type := DMGID_PHYSICAL;
    If( Ammo )
    Damage_Type := DMGID_RANGED;
    Endif

    Var RawDamage;
    SkillID := FindSkillidByIdentifier( Weapon_Att_CFGElem.Attribute );
    Var Diffaculty := GetAttribute( Attacker, GetAttributeIDBySkillID( SkillID ) );

    If( Diffaculty <= 0 )
    Diffaculty := 1;
    Endif

    If( Diffaculty >= 100 )
    Diffaculty := 100;
    Endif

    /*
    TODO: Hitscripts, Weapon Damages.
    */

    Var OnHitSound := Weapon_Att_CFGElem.HitSound;
    Var OnMissSound := Weapon_Att_CFGElem.HitSound;
    Var SwingAnim := Weapon_Att_CFGElem.Anim;

    If( Ammo )

      If ( !ConsumeSubstance( Attacker.backpack, Ammo, 1 ) )
      SendSysMessage( Attacker, "You do not have any ammo!" );
      Return 1;
      Endif

        If( CheckSkill( Attacker, SkillID, Diffaculty, 30 ) )
        RawDamage := CalculateRangedDamage( Attacker, Defender, RandomDiceRoll( Weapon_Att_CFGElem.Damage ), Damage_Type );
        /*
          If( OnHitSound )
          PlaySoundEffect( Defender, OnHitSound );
          PlaySoundEffect( Attacker, OnHitSound );
          Endif
          If( SwingAnim )
          PerformAction( Attacker, SwingAnim );
          Endif
        PerformAction( Defender, 0x0014 );
        */
        ApplyTheDamage( Defender, Attacker, Floor( RawDamage ) );
        Else
        SendSysMessage( Attacker, "You missed your opponent." );
        /*
          If( OnMissSound )
          PlaySoundEffect( Defender, OnMissSound );
          PlaySoundEffect( Attacker, OnMissSound );
          Endif
          If( SwingAnim )
          PerformAction( Attacker, SwingAnim );
          Endif
        */
        Endif

      Var Animation := Weapon_Att_CFGElem.ProjectileAnim;
      If( Animation )
      PlayMovingEffect( Attacker, Defender, Animation, 10, 10);
      Endif

    Return 1;
    Else

    Var TacticDif := GetAttribute( Attacker, "Tactics" );

    If( TacticDif <= 0 )
    TacticDif := 1;
    Endif

    If( TacticDif >= 100 )
    TacticDif := 100;
    Endif

      If( CheckSkill( Attacker, SkillID, Diffaculty, 30 ) && CheckSkill( Attacker, 27, TacticDif, 30 ) )
      RawDamage := CalculatePhysicalDamage( Attacker, Defender, ( RandomDiceRoll( Weapon_Att_CFGElem.Damage ) + Weapon_Attacker.dmg_mod ), Damage_Type );
      /*
        If( OnHitSound )
        PlaySoundEffect( Defender, OnHitSound );
        PlaySoundEffect( Attacker, OnHitSound );
        Endif
        If( SwingAnim )
        PerformAction( Attacker, SwingAnim );
        Endif
      PerformAction( Defender, 0x0014 );
      */
      ApplyTheDamage( Defender, Attacker, Floor( RawDamage ) );
      Else
      SendSysMessage( Attacker, "You missed your opponent." );
      /*
        If( OnMissSound )
        PlaySoundEffect( Defender, OnMissSound );
        PlaySoundEffect( Attacker, OnMissSound );
        Endif
        If( SwingAnim )
        PerformAction( Attacker, SwingAnim );
        Endif
      */
      Endif

    Return 1;
    Endif


Endfunction

Function FindSkillidByIdentifier( skid )

    Var retval;

    Case(skid)
    "Wrestling":     retval := SKILLID_WRESTLING;
    "Fencing":       retval := SKILLID_FENCING;
    "Swords":        retval := SKILLID_SWORDSMANSHIP;
    "Swordsmanship": retval := SKILLID_SWORDSMANSHIP;
    "Mace":          retval := SKILLID_MACEFIGHTING;
    "Macefighting":  retval := SKILLID_MACEFIGHTING;
    "Archery":       retval := SKILLID_ARCHERY;
    Endcase

    Return retval;

Endfunction

Function CalculateRangedDamage( Attacker, Defender, RawDamage, Damage_Type )

    Var LoreMod := GetAttribute( Attacker, ATTRIBUTEID_ANIMALLORE );
    Var ArchMod := GetAttribute( Attacker, ATTRIBUTEID_ARCHERY );
    Var DexMod := GetAttribute( Attacker, "dexterity" );

    RawDamage := RawDamage + CalcPercent( ArchMod, 0.002, RawDamage );
    RawDamage := RawDamage + CalcPercent( LoreMod, 0.002, RawDamage );
    RawDamage := RawDamage + CalcPercent( DexMod, 0.001, RawDamage );

    If( Defender.IsA( POLCLASS_NPC ) )
    RawDamage := RawDamage * ClasseBonus( Attacker, CLASSEID_RANGER );
    Else
    Var Level := GetObjProperty( Attacker, CLASSEID_RANGER );
      If( Level )
      Level := Level - 2;
        If( Level >= 1 )
        RawDamage := RawDamage * ClasseBonusByLevel( Level );
        Endif
      Endif
    Endif

    Var Script := Weapon_Attacker.hitscript;
    If( Script != "mainhit" && Script != "wrestlinghitscript" )
    CheckHitScript( Attacker, Defender, Weapon_Attacker, RawDamage, Script );
    Endif

    CheckPoison( Attacker, Defender );

    RawDamage := CalcByClasse( Attacker, Defender, RawDamage );
    RawDamage := ArmorCheck( Attacker, Defender, RawDamage, Damage_Type );
    RawDamage := ParryCheck( Attacker, Defender, RawDamage, Damage_Type );

    Return RawDamage;

Endfunction

Function CalculatePhysicalDamage( Attacker, Defender, RawDamage, Damage_Type )

    Var AnaMod := GetAttribute( Attacker, ATTRIBUTEID_ANATOMY );
    Var SkillMod := GetAttribute( Attacker, GetAttributeIDBySkillID( SkillID ) );
    Var StrMod := GetAttribute( Attacker, "strength" );

    RawDamage := RawDamage + CalcPercent( SkillMod, 0.002, RawDamage );
    RawDamage := RawDamage + CalcPercent( AnaMod, 0.002, RawDamage );
    RawDamage := RawDamage + CalcPercent( StrMod, 0.001, RawDamage );

    If( Defender.IsA( POLCLASS_NPC ) )
    RawDamage := RawDamage * ClasseBonus( Attacker, CLASSEID_WARRIOR );
    Else
    Var Level := GetObjProperty( Attacker, CLASSEID_WARRIOR );
      If( Level )
      Level := Level - 2;
        If( Level >= 1 )
        RawDamage := RawDamage * ClasseBonusByLevel( Level );
        Endif
      Endif
    Endif

    Var Script := Weapon_Attacker.hitscript;
    If( Script != "mainhit" && Script != "wrestlinghitscript" )
    CheckHitScript( Attacker, Defender, Weapon_Attacker, RawDamage, Script );
    Endif

    CheckPoison( Attacker, Defender );

    RawDamage := CalcByClasse( Attacker, Defender, RawDamage );
    RawDamage := CalcSlayer( Attacker, Defender, RawDamage );
    RawDamage := ArmorCheck( Attacker, Defender, RawDamage, Damage_Type );
    RawDamage := ParryCheck( Attacker, Defender, RawDamage, Damage_Type );

    Return RawDamage;

Endfunction

Function CalcPercent( Number, Multiplier, RawDamage )

    Number := ( Number + Random( 25 ) ) * Multiplier;
    If( Number >= 1.0 )
    Number := 0.90;
    Endif
    Number := ( RawDamage * Number );

    Return Number;

Endfunction

Function ParryCheck( Attacker, Defender, RawDamage, Damage_Type := DMGID_PHYSICAL )

    Var Shield_Defender := GetEquipmentByLayer( Defender, LAYER_HAND2 );
    If( !Shield_Defender.IsA( POLCLASS_ARMOR ) )
    Shield_Defender := GetEquipmentByLayer( Defender, LAYER_HAND1 );
    Endif

    If( Shield_Defender.IsA( POLCLASS_ARMOR ) )
    Var Parry_Chance := GetAttribute( defender, ATTRIBUTEID_PARRY );
    Parry_Chance := CInt( GetAttribute( defender, ATTRIBUTEID_PARRY ) * ClasseBonus( attacker, CLASSEID_WARRIOR ) );
      If( ( Random( 200 ) + 1 ) <= ( Parry_Chance / 2 ) )
      Var Absorbed := 0;
        If( Damage_Type == DMGID_RANGED )
        Absorbed := CInt( Shield_Defender.ar );
        SendSysMessage( Defender, "You successfully parry the attack." );
        SendSysMessage( Attacker, "Your opponent deflected the arrow with their shield." );
        PerformAction( Defender, ANIM_ATTACK_XBOW );
        Else
        Absorbed := ( Shield_Defender.ar / 2 );
        SendSysMessage( Defender, "You successfully parry the attack." );
        SendSysMessage( Attacker, "Your opponent parried the attack." );
        PerformAction( Defender, ANIM_ATTACK_XBOW );
        Endif
        RawDamage := ( RawDamage - Absorbed );
      Endif
    Endif

    Return RawDamage;

Endfunction

Function ArmorCheck( Attacker, Defender, RawDamage, Damage_Type := DMGID_PHYSICAL )

    Var Armor_Defender := Defender.ar;
    If( !Armor_Defender )
    Armor_Defender := 0;
    Endif

    Var Absorbed := 0;
    Var Piercing := Weapon_Attacker.hitscript;

    If( Piercing == "piercingscript" )
    Piercing := 1;
    SendSysMessage( Attacker, "Your weapon pierces through their armor." );
    Else
    Piercing := 0;
    Endif

    If( !Piercing )
    Absorbed  := CalcPercent( Armor_Defender, 0.002, RawDamage );
    Endif

    RawDamage := ( RawDamage - Absorbed );

    RawDamage := Protected( Defender, RawDamage );

    WearDownEquipment( Attacker, Defender, RawDamage );

    Return RawDamage;

Endfunction

Function Protected( Defender, RawDamage )

    Var PhysicalProtection := GetObjProperty( Defender, "PhysicalProtection" );
    If( !PhysicalProtection )
    Return RawDamage;
    Else
    PhysicalProtection := ( PhysicalProtection * 0.05 );
    If( PhysicalProtection >= 1 )
    PhysicalProtection := 0.90;
    Endif
    PhysicalProtection := ( RawDamage * PhysicalProtection );
    RawDamage := RawDamage - PhysicalProtection;
    Return RawDamage;
    Endif

Endfunction

Function CalcByClasse( Attacker, Defender, RawDamage )

    If( GetObjProperty( Attacker, CLASSEID_MAGE ) )
     If( !GetObjProperty( Attacker, CLASSEID_WARRIOR ) )
     RawDamage := RawDamage / ClasseBonus( Attacker, CLASSEID_MAGE );
     Endif
    Endif

    If( GetObjProperty( Defender, CLASSEID_MAGE ) )
     If( !GetObjProperty( Defender, CLASSEID_WARRIOR ) )
     RawDamage := RawDamage * ClasseBonus( Defender, CLASSEID_MAGE );
     Endif
    Endif

    If( GetObjProperty( Defender, CLASSEID_WARRIOR ) )
      If( Attacker.IsA( POLCLASS_NPC ) )
      RawDamage := ( rawdamage / ClasseBonus( Defender, CLASSEID_WARRIOR ) );
      Else
        Var Level := GetObjProperty( Defender, CLASSEID_WARRIOR );
        If( Level )
        Level := Level - 1;
         If( Level >= 1 )
         RawDamage := ( RawDamage / ClasseBonusByLevel( Level ) );
         Endif
        Endif
      Endif
    Endif

    Return RawDamage;

Endfunction

Function CheckPoison( Attacker, Defender )

    Var SkillPoisoned := GetObjProperty( Weapon_Attacker, "SkillPoisoned" );

    If( SkillPoisoned )
    Var PoisonLvl := CInt( SkillPoisoned / 3 );
    SkillPoisoned := SkillPoisoned - 1;
      If( SkillPoisoned )
      SetObjProperty( Weapon_Attacker, "SkillPoisoned", SkillPoisoned );
      Else
      EraseObjProperty( Weapon_Attacker, "SkillPoisoned" );
      Endif
    SetPoison( Defender, PoisonLvl, "You have been poisoned by " + Attacker.name + "." );
    Return 1;
    Endif

    Var WeaponPoisoned := GetObjProperty( Weapon_Attacker, "Poisonlvl" );
    Var Targ;

    If( GetObjProperty( Weapon_Attacker, "Cursed" ) )
    Targ := Attacker;
    Else
    Targ := Defender;
    Endif

    If( WeaponPoisoned )
    SetPoison( Targ, WeaponPoisoned, "You have been poisoned by " + Attacker.name + "." );
    Return 1;
    Endif

Endfunction

Function CalcSlayer( Attacker, Defender, RawDamage )

    Var SlayType := GetObjProperty( Weapon_Attacker, "SlayType" );
    Var Type := GetObjProperty( Defender, "Type" );

    If( SlayType == Type )
    RawDamage := RawDamage * 2;
    Return RawDamage;
    Elseif( SlayType == "Human" && !Defender.npctemplate )
    RawDamage := RawDamage * 1.5;
    Return RawDamage;
    Endif

    Return RawDamage;

Endfunction

Function CheckHitScript( Attacker, Defender, Weapon_Attacker, RawDamage, Script )

    Script := ":combat:" + Script;

    Start_Script( Script, { Attacker, Defender, Weapon_Attacker, RawDamage } );

Endfunction

Function WearDownEquipment( Attacker, Defender, RawDamage )

    Var Zone := GetHitZone( Defender );
    Var List := GetEquipInArmorZone( Defender, Zone );

    Foreach item in List
    Var ar := item.ar;
    If( RawDamage > CInt( 0.15 * item.hp ) )
      If( Random( 100 ) < 5 )
      SendSysMessage( Defender, item.desc + " takes some damage." );
      item.quality := item.quality - 0.10;
        If( item.quality <= 0.1 )
        DestroyEquipment( Defender, item );
        Elseif( item.hp > item.maxhp )
        item.hp := item.maxhp;
        Endif
      Endif
    Endif
    RawDamage := RawDamage - RandomInt( ar );
    Endforeach

Endfunction

Function DestroyEquipment( who, item )

    Var cursed := GetObjProperty( item, "Cursed" );

    If( cursed )
    SetObjProperty( item, "Cursed", 3 );
    Endif

    If( who.backpack )
    MoveItemToContainer( item, who.backpack );
    Endif

    SendSysMessage( who, item.desc + " has been destroyed." );

    DestroyItem( item );

Endfunction
