//randname.inc
//
//assigns a random name from the list according to obtype and gender

use uo;
use os;
use basic;
use util;

include "include/random";

const BIRD_IDX := 1;
const DAEMON_IDX := 2;
const DRAGON_IDX := 3;
//Const EVILMAGE_IDX := 4;
const MALE_IDX := 5;
const FEMALE_IDX := 6;
//Const PIRATE_MALE_IDX := 7;
//Const PIRATE_FEMALE_IDX := 8;
const LIZARD_IDX := 9;
const ORC_IDX := 10;
const OGRE_IDX := 11;
const RATMAN_IDX := 12;

const OBJ_BIRD := 0x6;
const OBJ_DAEMON := 0x9;
const OBJ_DAEMON_SWORD := 0xa;
const OBJ_DRAGON_RED := 0x3d;
const OBJ_DRAGON_GREY := 0xc;
//Const OBJ_EVILMAGE :=
const OBJ_MALE := 0x190;
const OBJ_FEMALE := 0x191;
//Const OBJ_PIRATE_MALE :=
//Const OBJ_PIRATE_FEMALE :=
const OBJ_LIZARD := 0x21;
const OBJ_LIZARD_MACE := 0x24;
const OBJ_LIZARD_SPEAR := 0x23;

const OBJ_ORC := 0x11;
const OBJ_ORC_CLUB := 0x29;
const OBJ_ORC_CAPT := 0x7;

const OBJ_OGRE := 0x1;

const OBJ_RATMAN := 0x2a;
const OBJ_RATMAN_SWORD := 0x2d;
const OBJ_RATMAN_AXE := 0x2c;

function RandomName( me )

	var newname := " ";
	case( me.graphic )
	    OBJ_BIRD:		newname := AssignName( me, BIRD_IDX );
	    OBJ_DAEMON:		newname := AssignName( me, DAEMON_IDX );
	    OBJ_DAEMON_SWORD:	newname := AssignName( me, DAEMON_IDX );
	    OBJ_DRAGON_RED:	newname := AssignName( me, DRAGON_IDX );
	    OBJ_DRAGON_GREY: 	newname := AssignName( me, DRAGON_IDX );
	    OBJ_MALE: 		newname := AssignName( me, MALE_IDX );
	    OBJ_FEMALE:		newname := AssignName( me, FEMALE_IDX );
	    OBJ_LIZARD:		newname := AssignName( me, LIZARD_IDX );
	    OBJ_LIZARD_MACE:	newname := AssignName( me, LIZARD_IDX );
	    OBJ_LIZARD_SPEAR:	newname := AssignName( me, LIZARD_IDX );
	    OBJ_ORC:		newname := AssignName( me, ORC_IDX );
	    OBJ_ORC_CLUB:	newname := AssignName( me, ORC_IDX );
	    OBJ_ORC_CAPT:	newname := AssignName( me, ORC_IDX );
	    OBJ_OGRE:		newname := AssignName( me, OGRE_IDX );
	    OBJ_RATMAN:		newname := AssignName( me, RATMAN_IDX );
	    OBJ_RATMAN_SWORD:	newname := AssignName( me, RATMAN_IDX );
	    OBJ_RATMAN_AXE:	newname := AssignName( me, RATMAN_IDX );
	    0x22a:
	    0x1b3:		if( RandomInt(2) )
	    				newname := AssignName( me, MALE_IDX );
	    			else
	    				newname := AssignName( me, FEMALE_IDX );
	    			endif
	    default: 		exit;
	endcase

	return(newname);
endfunction


function AssignName( me, index )

    var cfg := ReadConfigFile( "names" );
    var elem := FindConfigElem( cfg, index );
    var number := GetConfigInt( elem, "Count" );

    var dice_str := "1d" + CStr(number);

    var choice := RandomDiceStr( dice_str );
    var entry := "Name" + choice;

    var str := GetConfigString( elem, entry );
    var title := PreserveTitle( me );
  
    str := str + title;

    return( str );

endfunction


function PreserveTitle( me )

  var myname := me.name;
  var start := find( myname, ">", 1 );

if( !start )
  return;
endif

  var title := myname[ start+1, (len( myname ) - 8) ];

if( !title )
  return("");
endif

  return( title );

endfunction



