/*
   Author: Unreal (MontuZ@Gmail.com) Nov 08, 2005.
   Version: 0.5
   Core: 093
   Bugs: None. Atleast none that I know of..
   PS: You know it was done by me when it's so clean.
*/

Const FRAGPOINTS     := "FragPoints";
Const DEATHPOINTS    := "DeathPoints";
Const FRAGGER_SERIAL := "FraggerSerial";
Const FRAGGED_SERIAL := "FraggedSerial";
Const FRAGGED_TIME   := "FraggedTime";
Const FRAG_WAITTIME  := 600; /* 10 Minutes = 600 Seconds */

Const RANKID_IMAGE    := "RankImage";
Const RANKID_NAME     := "RankName";

Const RANKID_NONE     := "None";
Const RANKID_PRIV     := "IsPrivate";
Const RANKID_CORP     := "IsCorporal";
Const RANKID_SERG     := "IsSergeant";
Const RANKID_MSERG    := "IsMasterSergeant";
Const RANKID_SMSERG   := "IsSeniorMasterSergeant";
Const RANKID_BRIGCOL  := "IsBrigadierColonel";
Const RANKID_MAJCOL   := "IsMajorColonel";
Const RANKID_LTCOL    := "IsLieutenantColonel";
Const RANKID_COL      := "IsColonel";
Const RANKID_BRIGCOM  := "IsBrigadierCommander";
Const RANKID_COM      := "IsCommander";
Const RANKID_BRIGGEN  := "IsBrigadierGeneral";
Const RANKID_MAJGEN   := "IsMajorGeneral";
Const RANKID_GEN      := "IsGeneral";

Include "util/bank";
Include "include/areas";
Include "include/client";
Include "include/time";
Include "include/jail";
Include "include/yesno";

Function AwardFrag( Who )

    Var FgrSrl := GetObjProperty( Who, FRAGGER_SERIAL );
    Var Fgr := SystemFindObjectBySerial( FgrSrl );
    
    If( Fgr )
        If( Fgr.IsA( POLCLASS_MOBILE ) && !Fgr.IsA( POLCLASS_NPC ) )
          If( !IsOpposingFaction( Who, Fgr ) )
			If( YesNo(Who, "Jail the person that killed you?") )
			Var Days := 99 * 86400;
			(Fgr.acct).SetProp( "Release", ( PolCore().Systime + Days ) );
			SendPlayerToJail( Fgr );
			Var NewNote := "Killing a member of the same faction.";
			Var xNotes := (Fgr.acct).GetProp( "xNotes" );
			If( !xNotes )
				xNotes := Array;
			Endif
			Var Seconds := PolCore().systime;
			xNotes.Append( { Who.serial, GetDateString( Seconds ) + " at " + GetTimeString( Seconds ), NewNote } );
			(Fgr.acct).SetProp( "xNotes", xNotes );
			SendSysMessage( Fgr, "You have been jailed for killing a person from the same faction!" );
			Endif
			Return 0;
          Endif
            If( !Who.multi )
                If( WaitTimer( Who ) )
                Var Frags := GetFrags( Fgr );
                Var Deaths := GetDeaths( Who );
                SetObjProperty( Fgr, FRAGPOINTS, Frags + 1 );
                SetObjProperty( Who, DEATHPOINTS, Deaths + 1 );
                SendSysMessage( Fgr, "You've gained 1 frag point!" );
                Broadcast( Who.name + " was slain by " + Fgr.name + "." );
                AssignRank( Fgr );
                start_script( "registerguilds" );
				Return 1;
                Else
                SendSysMessage( Fgr, "That player isn't worth any frag points, yet." );
                Broadcast( Who.name + " was slain by " + Fgr.name + "." );
				Return 1;
                Endif
            Endif
        Endif
    Endif

Endfunction

Function LogKill( Killer, Killed )

    Var datafile := ReadConfigFile("Logging/FragRecords");

    If (datafile)

    Var elem;
    elem:={ };
    elem.append({ "Killer Name",  Killer.name });
    elem.append({ "Killer Serial",  Hex( Killer.serial) });
    elem.append({ "Killer IP",  Killer.ip });
    elem.append({ "Killed Name",    Killed.name });
    elem.append({ "Killed Serial",  Hex( Killed.serial) });
    elem.append({ "Killed IP",  Killed.ip });
    elem.append({ "TimeOfKill", GetDateString( polcore().systime ) });

    AppendConfigFileElem( "Logging/FragRecords", "PointEarnedBy", Killer.name , elem );
    UnloadConfigFile( "Logging/FragRecords" );
    EndIf

Endfunction

Function WaitTimer( Who )

    Var Timer := GetObjProperty( Who, FRAGGED_TIME );

    If( !Timer )
    SetObjProperty( Who, FRAGGED_TIME, ReadGameClock() + FRAG_WAITTIME );
    Return 1;
    Endif
    
    If( Timer < ReadGameClock() )
    EraseObjProperty( Who, FRAGGED_TIME );
    SetObjProperty( Who, FRAGGED_TIME, ReadGameClock() + FRAG_WAITTIME );
    Return 1;
    Endif
    
    If( Timer > ReadGameClock() )
    Return 0;
    Endif

Endfunction

Function GetFrags( Who )

    Var Frags := Cint( GetObjProperty( Who, FRAGPOINTS ) );
    
    If( !Frags )
    SetObjProperty( Who, FRAGPOINTS, 0 );
    Frags := Cint( GetObjProperty( Who, FRAGPOINTS ) );
    Endif
    
    Return Frags;
    
Endfunction

Function GetDeaths( Who )

    Var Deaths := Cint( GetObjProperty( Who, DEATHPOINTS ) );

    If( !Deaths )
    SetObjProperty( Who, DEATHPOINTS, 0 );
    Deaths := Cint( GetObjProperty( Who, DEATHPOINTS ) );
    Endif
    
    Return Deaths;

Endfunction

Function AssignRank( Who )

    CleanupRanks( Who );

    Var Rnk;
    Var RnkImg;
    Var rank;
    Var LstRnk := GetObjProperty( Who, "LastRank" );

    rank := GetRankId( Who );
    If( LstRnk != rank )
        Rnk := GetRankName( rank );
        RnkImg := GetRankImage( rank );
        SetObjProperty( Who , rank , rank );
        SetObjProperty( Who , "RankID" , rank );
        EraseObjProperty( Who , "LastRank" );
        SetObjProperty( Who , "LastRank" , rank );
        SetObjProperty( Who , RANKID_NAME , Rnk );
        SetObjProperty( Who , RANKID_IMAGE , RnkImg );
        SendSysMessage( Who, "You've earned the rank, " + Rnk );
        If( Rnk == "None" )
        Rnk := "";
        Endif
        Who.title_prefix := Rnk;
        Else
        Rnk := GetRankName( rank );
        RnkImg := GetRankImage( rank );
        SetObjProperty( Who , rank , rank );
        SetObjProperty( Who , "RankID" , rank );
        EraseObjProperty( Who , "LastRank" );
        SetObjProperty( Who , "LastRank" , rank );
        SetObjProperty( Who , RANKID_NAME , Rnk );
        SetObjProperty( Who , RANKID_IMAGE , RnkImg );
        If( Rnk == "None" )
        Rnk := "";
        Endif
        Who.title_prefix := Rnk;
    Endif

Endfunction

Function CleanupRanks( Who )

    EraseObjProperty( Who , "RankID" );
    EraseObjProperty( Who , RANKID_NAME );
    EraseObjProperty( Who , RANKID_IMAGE );
    
    EraseObjProperty( Who , RANKID_PRIV );
    EraseObjProperty( Who , RANKID_CORP );
    EraseObjProperty( Who , RANKID_SERG );
    EraseObjProperty( Who , RANKID_MSERG );
    EraseObjProperty( Who , RANKID_SMSERG );
    EraseObjProperty( Who , RANKID_BRIGCOL );
    EraseObjProperty( Who , RANKID_LTCOL );
    EraseObjProperty( Who , RANKID_COL );
    EraseObjProperty( Who , RANKID_BRIGCOM );
    EraseObjProperty( Who , RANKID_COM );
    EraseObjProperty( Who , RANKID_NAME );
    EraseObjProperty( Who , RANKID_IMAGE );
    EraseObjProperty( Who , RANKID_BRIGGEN );
    EraseObjProperty( Who , RANKID_MAJGEN );
    EraseObjProperty( Who , RANKID_GEN );
    
    Return 1;

Endfunction

Function GetRankIds()

    Return
    {
    RANKID_PRIV,
    RANKID_CORP,
    RANKID_SERG,
    RANKID_MSERG,
    RANKID_SMSERG,
    RANKID_BRIGCOL,
    RANKID_MAJCOL,
    RANKID_LTCOL,
    RANKID_COL,
    RANKID_BRIGCOM,
    RANKID_COM,
    RANKID_BRIGGEN,
    RANKID_MAJGEN,
    RANKID_GEN
    };

Endfunction

Function GetRankName( rankid )

    Case( rankid )
    RANKID_PRIV:     Return( "Private" );
    RANKID_CORP:     Return( "Corporal" );
    RANKID_SERG:     Return( "Sergeant" );
    RANKID_MSERG:    Return( "Master Sergeant" );
    RANKID_SMSERG:   Return( "Senior Master Sergeant" );
    RANKID_BRIGCOL:  Return( "Brigadier Colonel" );
    RANKID_MAJCOL:   Return( "Major Colonel" );
    RANKID_LTCOL:    Return( "Lieutenant Colonel" );
    RANKID_COL:      Return( "Colonel" );
    RANKID_BRIGCOM:  Return( "Brigadier Commander" );
    RANKID_COM:      Return( "Commander" );
    RANKID_BRIGGEN:  Return( "Brigadier General" );
    RANKID_MAJGEN:   Return( "Major General" );
    RANKID_GEN:      Return( "General" );
    default:         Return( "None" );
    Endcase

Endfunction

Function GetRankImage( rankid )

    Case( rankid )
    RANKID_PRIV:     Return( "rank01" );
    RANKID_CORP:     Return( "rank02" );
    RANKID_SERG:     Return( "rank03" );
    RANKID_MSERG:    Return( "rank04" );
    RANKID_SMSERG:   Return( "rank05" );
    RANKID_BRIGCOL:  Return( "rank06" );
    RANKID_MAJCOL:   Return( "rank07" );
    RANKID_LTCOL:    Return( "rank08" );
    RANKID_COL:      Return( "rank09" );
    RANKID_BRIGCOM:  Return( "rank10" );
    RANKID_COM:      Return( "rank11" );
    RANKID_BRIGGEN:  Return( "rank12" );
    RANKID_MAJGEN:   Return( "rank13" );
    RANKID_GEN:      Return( "rank14" );
    default:         Return( "blank" );
    Endcase

Endfunction

Function GetRankKills( rankid )

    Case( rankid )
    RANKID_PRIV:     Return 50;
    RANKID_CORP:     Return 100;
    RANKID_SERG:     Return 200;
    RANKID_MSERG:    Return 400;
    RANKID_SMSERG:   Return 800;
    RANKID_BRIGCOL:  Return 1300;
    RANKID_MAJCOL:   Return 1800;
    RANKID_LTCOL:    Return 2300;
    RANKID_COL:      Return 2800;
    RANKID_BRIGCOM:  Return 3800;
    RANKID_COM:      Return 4800;
    RANKID_BRIGGEN:  Return 6800;
    RANKID_MAJGEN:   Return 8800;
    RANKID_GEN:      Return 10000;
    default:         Return 0;
    Endcase

Endfunction

Function GetRank2( Kills )

    Case( Kills )
    50:      Return RANKID_PRIV;
    100:     Return RANKID_CORP;
    200:     Return RANKID_SERG;
    400:     Return RANKID_MSERG;
    800:     Return RANKID_SMSERG;
    1300:    Return RANKID_BRIGCOL;
    1800:    Return RANKID_MAJCOL;
    2300:    Return RANKID_LTCOL;
    2800:    Return RANKID_COL;
    3800:    Return RANKID_BRIGCOM;
    4800:    Return RANKID_COM;
    6800:    Return RANKID_BRIGGEN;
    8800:    Return RANKID_MAJGEN;
    10000:      Return RANKID_GEN;
    default:         Return 0;
    Endcase

Endfunction

Function GetRankId( Who )

    Var Frags := GetFrags( Who );
    Var Deaths := GetDeaths( Who );
    Var TotalScore := Frags - Deaths;
   
   If( TotalScore >= 10000 )
   Return RANKID_GEN;
   Elseif( TotalScore >= 8800 )
   Return RANKID_MAJGEN;
   Elseif( TotalScore >= 6800 )
   Return RANKID_BRIGGEN;
   Elseif( TotalScore >= 4800 )
   Return RANKID_COM;
   Elseif( TotalScore >= 3800 )
   Return RANKID_BRIGCOM;
   Elseif( TotalScore >= 2800 )
   Return RANKID_COL;
   Elseif( TotalScore >= 2300 )
   Return RANKID_LTCOL;
   Elseif( TotalScore >= 1800 )
   Return RANKID_MAJCOL;
   Elseif( TotalScore >= 1300 )
   Return RANKID_BRIGCOL;
   Elseif( TotalScore >= 800 )
   Return RANKID_SMSERG;
   Elseif( TotalScore >= 400 )
   Return RANKID_MSERG;
   Elseif( TotalScore >= 200 )
   Return RANKID_SERG;
   Elseif( TotalScore >= 100 )
   Return RANKID_CORP;
   Elseif( TotalScore >= 50 )
   Return RANKID_PRIV;
   Endif

   Return 0;

Endfunction

Function AwardReward( Who, rankid )

   Var item;

    If( RANKID_PRIV == rankid )
    item := CreateItemInContainer( Who.backpack, 0x153B, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x153B, 1 );
        item.color := 2557;
        item.name := "Private's Half Apron";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "FreeAction", 1 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Private's Half Apron";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "FreeAction", 1 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_CORP == rankid )
    item := CreateItemInContainer( Who.backpack, 0x153B, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x153B, 1 );
        item.color := 2557;
        item.name := "Corporal's Half Apron";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "FreeAction", 1 );
        SetObjProperty( item, "PhysicalProtection", 1 );
        SetObjProperty( item, "HealingIncrease", 1 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Corporal's Half Apron";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "FreeAction", 1 );
        SetObjProperty( item, "PhysicalProtection", 1 );
        SetObjProperty( item, "HealingIncrease", 1 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_SERG == rankid )
    item := CreateItemInContainer( Who.backpack, 0x153B, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x153B, 1 );
        item.color := 2557;
        item.name := "Sergeant's Half Apron";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "FreeAction", 1 );
        SetObjProperty( item, "PhysicalProtection", 2 );
        SetObjProperty( item, "HealingIncrease", 2 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Sergeant's Half Apron";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "FreeAction", 1 );
        SetObjProperty( item, "PhysicalProtection", 2 );
        SetObjProperty( item, "HealingIncrease", 2 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_MSERG == rankid )
    item := CreateItemInContainer( Who.backpack, 0x153B, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x153B, 1 );
        item.color := 2557;
        item.name := "Master Sergeant's Half Apron";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "FreeAction", 1 );
        SetObjProperty( item, "PhysicalProtection", 4 );
        SetObjProperty( item, "HealingIncrease", 4 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Master Sergeant's Half Apron";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "FreeAction", 1 );
        SetObjProperty( item, "PhysicalProtection", 4 );
        SetObjProperty( item, "HealingIncrease", 4 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_SMSERG == rankid )
    item := CreateItemInContainer( Who.backpack, 0x153B, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x153B, 1 );
        item.color := 2557;
        item.name := "Senior Master Sergeant's Half Apron";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "FreeAction", 1 );
        SetObjProperty( item, "PhysicalProtection", 6 );
        SetObjProperty( item, "HealingIncrease", 6 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Senior Master Sergeant's Half Apron";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "FreeAction", 1 );
        SetObjProperty( item, "PhysicalProtection", 6 );
        SetObjProperty( item, "HealingIncrease", 6 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_BRIGCOL == rankid )
    item := CreateItemInContainer( Who.backpack, 0x1F7B, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x1F7B, 1 );
        item.color := 2557;
        item.name := "Brigadier Champion's Doublet";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 5 );
        SetObjProperty( item, "dex", 5 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Brigadier Champion's Doublet";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 5 );
        SetObjProperty( item, "dex", 5 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_MAJCOL == rankid )
    item := CreateItemInContainer( Who.backpack, 0x1F7B, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x1F7B, 1 );
        item.color := 2557;
        item.name := "Major Champion's Doublet";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 10 );
        SetObjProperty( item, "dex", 10 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Major Champion's Doublet";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 10 );
        SetObjProperty( item, "dex", 10 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_LTCOL == rankid )
    item := CreateItemInContainer( Who.backpack, 0x1F7B, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x1F7B, 1 );
        item.color := 2557;
        item.name := "Lieutenant Champion's Doublet";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 20 );
        SetObjProperty( item, "dex", 20 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Lieutenant Champion's Doublet";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 20 );
        SetObjProperty( item, "dex", 20 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_COL == rankid )
    item := CreateItemInContainer( Who.backpack, 0x1F7B, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x1F7B, 1 );
        item.color := 2557;
        item.name := "Champion's Doublet";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 30 );
        SetObjProperty( item, "dex", 30 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Champion's Doublet";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 30 );
        SetObjProperty( item, "dex", 30 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_BRIGCOM == rankid )
    item := CreateItemInContainer( Who.backpack, 0x1515, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x1515, 1 );
        item.color := 2557;
        item.name := "Brigadier Commander's Cloak";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 15 );
        SetObjProperty( item, "int", 15 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Brigadier Commander's Cloak";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 15 );
        SetObjProperty( item, "int", 15 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_COM == rankid )
    item := CreateItemInContainer( Who.backpack, 0x1515, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x1515, 1 );
        item.color := 2557;
        item.name := "Commander's Cloak";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 30 );
        SetObjProperty( item, "int", 30 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Commander's Cloak";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 30 );
        SetObjProperty( item, "int", 30 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_BRIGGEN == rankid )
    item := CreateItemInContainer( Who.backpack, 0x1F03, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x1F03, 1 );
        item.color := 2557;
        item.name := "Brigadier General's Robe";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 10 );
        SetObjProperty( item, "int", 10 );
        SetObjProperty( item, "dex", 10 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Brigadier General's Robe";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 10 );
        SetObjProperty( item, "int", 10 );
        SetObjProperty( item, "dex", 10 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_MAJGEN == rankid )
    item := CreateItemInContainer( Who.backpack, 0x1F03, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x1F03, 1 );
        item.color := 2557;
        item.name := "Major General's Robe";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 20 );
        SetObjProperty( item, "int", 20 );
        SetObjProperty( item, "dex", 20 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "Major General's Robe";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 20 );
        SetObjProperty( item, "int", 20 );
        SetObjProperty( item, "dex", 20 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Elseif( RANKID_GEN == rankid )
    item := CreateItemInContainer( Who.backpack, 0x1F03, 1 );
        If( !item )
        Var bank := FindBankBox( Who );
        item := CreateItemInContainer( bank, 0x1F03, 1 );
        item.color := 2557;
        item.name := "General's Robe";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 30 );
        SetObjProperty( item, "int", 30 );
        SetObjProperty( item, "dex", 30 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        SendSysMessage( Who, "Your backpack was full so the reward was placed in you bank." );
        Else
        item.color := 2557;
        item.name := "General's Robe";
        item.newbie := 1;
        SetObjProperty( item, "ReqFrags", GetRankKills( rankid ) );
        SetObjProperty( item, "ArBonus", 6 );
        SetObjProperty( item, "str", 30 );
        SetObjProperty( item, "int", 30 );
        SetObjProperty( item, "dex", 30 );
        SendSysMessage( Who, "You've been rewarded a " + item.name );
        Endif
    Endif

Endfunction
