//////////////////////////////////////////////////////////////////////////////////
//										//
//	spelldata.inc : 							//
//										//
//	This file Include all the constant related to existing spells, as	//
//	well as useful fuction about spells. The first line of each spell	//
//	is the spellid, then his SFX anf finally his FX				//
//										//
//////////////////////////////////////////////////////////////////////////////////
/*
 TODO: Complete rewrite.
*/
Use uo;
Use os;
Use util;
Use basic;
Use cfgfile;

Include "include/client";
Include "include/random";
Include "include/eventid";
Include "include/sysevent";
Include "include/classes";
Include "include/damages";
Include "include/areas";

////////////////////////////////
// Spell functions' constants //
////////////////////////////////


// TryToCast return values
Const IN_ANTIMAGIC_AREA := 1;
Const INTERRUPTED       := 2;
Const INVALID_EQUIPMENT := 3;
Const NO_REGS           := 4;
Const NO_MANA           := 5;
Const NO_SKILL          := 6;
Const SUCCESS           := 7;


// Casting options
Const CASTINGOPT_PROP_NAME      := "CastingOpts";
Const PERM_CASTINGOPT_PROP_NAME := "PermCastingOpts";
Const CASTINGOPT_ANY_EQUIPMENT  := "ANYEQUIP";
Const CASTINGOPT_NO_WORDS       := "NOWORDS";
Const CASTINGOPT_NO_DELAY       := "NODELAY";
Const CASTINGOPT_NO_REAGENTS    := "NOREGS";
Const CASTINGOPT_NO_MANA        := "NOMANA";
Const CASTINGOPT_NO_SKILL_CHECK := "NOSKILL";


// CalcSpellDamage options
Const SINGLE_TARGET_SPELL := 0;
Const AREA_EFFECT_SPELL   := 1;

Const SPELL_DAMAGES_MAGERY_DIVIDER    := 7;
Const SPELL_DAMAGES_ON_PLAYER_DIVIDER := 3;
const SPELL_DAMAGES_CIRCLE_MULTIPLIER := 3; // number of dices to throw per circle
const SPELL_DAMAGES_DICE_TYPE         := 5; // type of dices to throw



// Immunities constants
Const IMMUNED	:= 1;
Const CURSED	:= 2;


// Elements contants
Const FIRE	:= 0x01;
Const AIR	:= 0x02;
Const EARTH	:= 0x04;
Const WATER	:= 0x08;
Const NECRO	:= 0x10;
Const HOLY	:= 0x20;


// Error messages
Const ERROR_MSG_ANTI_MAGIC_AREA		:= "Spells cannot be cast here.";
Const ERROR_MSG_FIZZLE			    := "The spell fizzles.";
Const ERROR_MSG_INTERRUPTED		    := "You were interrupted during the casting.";
Const ERROR_MSG_LOST_CONCENTRATION	:= "You've lost your concentration!";
Const ERROR_MSG_NOT_ENOUGH_REAGENTS	:= "You do not have enough reagents.";
Const ERROR_MSG_NOT_ENOUGH_MANA		:= "You do not have enough mana.";
Const ERROR_MSG_NOT_ENOUGH_SKILL	:= "This spell is above yours magical capacities.";
Const ERROR_MSG_NOT_IN_SIGHT		:= "You can't see that.";
Const ERROR_MSG_WRONG_EQUIPMENT		:= "Your hands must be free to cast spells.";


//////////////////////////////////////////////////////////////////////////////////////////////////
// Spell functions :										//
//	This Include all functions from spellrestrictions.inc, plus some more.			//
//	Don't erase the spellrestrictions however, unless you are certain that you changed	//
//	Include "include/spellrestrictions" from ALL pkgs that used it.	Some parameters of	//
//	the functions changed however.								//
//////////////////////////////////////////////////////////////////////////////////////////////////


Function ApplyElementalDamage( caster, cast_on, circle, dmg, element )

    If( caster.dead )
    Return;
    Endif
    
    If( cast_on.dead )
    Return;
    Endif

    dmg := Protects( cast_on, dmg, element );
    
    ApplyTheDamage( cast_on, caster, Resisted( caster, cast_on, circle, dmg ), DMGID_MAGIC + element );
    
Endfunction

Function CalcProt( Who, Whoelse, Number, RawDamage, BonusPerLvl := 0.5 )

    SendSysMessage( Who, "Protection#: " + Number );
    SendSysMessage( Whoelse, "Protection#: " + Number );
    SendSysMessage( Who, "ProtectionPer#: " + BonusPerLvl );
    SendSysMessage( Whoelse, "ProtectionPer#: " + BonusPerLvl );
    
    Number := Number * BonusPerLvl;
    
    SendSysMessage( Who, "Protection %: " + Number );
    SendSysMessage( Whoelse, "Protection %: " + Number );

    Number := ( RawDamage * Number );
    
    SendSysMessage( Who, "% Deducted: " + Number );
    SendSysMessage( Whoelse, "% Deducted: " + Number );
    
    RawDamage := ( RawDamage - Number );
    
    SendSysMessage( Who, "Deducted: " + RawDamage );
    SendSysMessage( Whoelse, "Deducted: " + RawDamage );

    Return Number;

Endfunction

Function Protects( Defender, RawDamage, Element )

    Var PhysicalProtection := GetProtLevel( Defender, Element );
    If( !PhysicalProtection )
    Return RawDamage;
    Else
    PhysicalProtection := ( PhysicalProtection * 0.10 );
    If( PhysicalProtection >= 1 )
    PhysicalProtection := 0.90;
    Endif
    PhysicalProtection := ( RawDamage * PhysicalProtection );
    RawDamage := RawDamage - PhysicalProtection;
    Endif

    Return RawDamage;

Endfunction

Function ApplyElementalDamageNoResist( on_who, by_who, dmg, element )

    If( on_who.dead )
    Return;
    Endif

    If( by_who.dead )
    Return;
    Endif

    dmg := Protects( on_who, dmg, element );
    
    ApplyTheDamage( on_who, by_who, dmg, element );

Endfunction


Function ApplyPlanarDamage( caster, cast_on, circle, dmg, plane )

    If( caster.dead )
    Return;
    Endif

    If( cast_on.dead )
    Return;
    Endif

    dmg := Protects( cast_on, dmg, plane );
    
    ApplyTheDamage( cast_on, caster, Resisted( caster, cast_on, circle, dmg ), DMGID_MAGIC + plane );

Endfunction


Function BurnSelf( caster, circle )

    If( caster.dead )
    Return;
    Endif

    Var dmg;
    Var cast_on := caster;
    dmg := CalcSpellDamage( caster, cast_on, circle );
    
    If( GetObjProperty( caster, CLASSEID_MAGE ) )
    dmg := CInt( dmg / ClasseBonus( caster, CLASSEID_MAGE ) );
    Elseif( GetObjProperty( caster, CLASSEID_WARRIOR ) )
    dmg := CInt( dmg * ClasseBonus( caster, CLASSEID_WARRIOR ) );
    Endif

    ApplyRawDamage( caster, Resisted( caster, circle, cast_on, CInt( dmg / 2 ) ) );

Endfunction


Function CalcSpellDamage( caster, cast_on, circle, area_spell := SINGLE_TARGET_SPELL )

    If( caster.dead )
    Return 0;
    Endif
    
    If( cast_on.dead )
    Return 0;
    Endif

    If( area_spell )
    circle := circle - 3;
    Endif

    If( circle < 1 )
    circle := 1;
    Endif

    Var MinDice := ( circle * SPELL_DAMAGES_CIRCLE_MULTIPLIER );
    Var MaxDice := ( SPELL_DAMAGES_DICE_TYPE );
    Var BonusD := CInt( GetAttribute( caster, ATTRIBUTEID_MAGERY ) / SPELL_DAMAGES_MAGERY_DIVIDER );

    Var dmg := RandomDiceRoll( MinDice + "d" + MaxDice + "+" + BonusD );

    Var EvalMod := GetAttribute( Caster, ATTRIBUTEID_EVALINT );
    Var IntMod := GetAttribute( Caster, ATTRIBUTEID_INTELLIGENCE );

    Dmg := Calculate_Mods( EvalMod, Dmg );
    Dmg := Calculate_Mods( IntMod, Dmg, 10 );

    If( dmg > CInt( circle * ( 13 + circle ) ) )
    dmg := CInt( circle * ( 13 + circle ) );
    Endif

    dmg := ModifyWithMagicEfficiency( caster, dmg );

    If( !cast_on.IsA( POLCLASS_NPC ) )
    dmg := CInt( dmg / SPELL_DAMAGES_ON_PLAYER_DIVIDER );
    Endif
    
    Var dist := Distance( caster, cast_on );
    If( ( dist <= 1 ) || ( dist > 10 ) )
    dmg := dmg * 0.50;
    Endif

    Return dmg;

Endfunction

Function Calculate_Mods( BaseMod, Value, Divider := 5, Multiplier := 0.01 )

    Var Percent := ( ( BaseMod / Divider ) * Multiplier ) + 1.0;
    Var xDamage := ( Value * Percent );

    Return xDamage;

Endfunction

Function colorstuff(who,ncolor)

Var item,i,armor:={0x03,0x04,0x05,0x06,0x07,0x0a,0x0c,0x0d,0x0e,0x11,0x13,0x14,0x16,0x17,0x18};

for(i:=1;i<=15;i:=i+1)
item:=GetEquipmentByLayer(who,armor[i]);

if (ncolor>=0)
item.color:=ncolor;
SetObjProperty(item,"X6",1);
else
DestroyItem(item);
Endif

endfor

Endfunction


Function Can_Cast( me, circle )

    If( me.dead )
    EraseObjProperty( me, "#Casting" );
    Return 0;
    Endif
    
    If( IsInAntiMagicArea( me ) )
    SendSysMessage( me, "Spells are disabled in this area.");
    EraseObjProperty( me, "#Casting" );
    Return 0;
    Endif

    Var max_circle := GetMaxCircle( me );
    If( max_circle )
      If( circle > max_circle )
      PlayObjectCenteredEffect( me, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
      PlaySoundEffect( me, SFX_SPELL_FIZZLE );
      SendSysMessage( me, ERROR_MSG_NOT_ENOUGH_SKILL );
      EraseObjProperty( me, "#Casting" );
      Return 0;
      Endif
    Endif

    Return 1;

Endfunction


Function CanTargetArea( caster, circle := 1 )

    If( !Can_Cast( caster, circle ) )
    Return 0;
    Endif

    Var cx := caster.x;
    Var cy := caster.y;
    Var shp := GetHp( caster );

    Var cast_loc := TargetCoordinates( caster );
    If( !cast_loc.x )
    EraseObjProperty( caster, "#Casting" );
    Return 0;
    Endif

    If( ( cx != caster.x ) || ( cy != caster.y ) || ( shp > GetHp( caster ) ) )
    SendSysMessage( caster, ERROR_MSG_LOST_CONCENTRATION );
    EraseObjProperty( caster, "#Casting" );
    Return 0;
    Endif

    If( !CheckLosAt( caster, cast_loc.x, cast_loc.y, cast_loc.z ) )
    SendSysMessage( caster, ERROR_MSG_NOT_IN_SIGHT );
    EraseObjProperty( caster, "#Casting" );
    Return 0;
    Endif

    Return cast_loc;

Endfunction


Function CanTargetSpell( caster, circle := 1, targopt := TGTOPT_CHECK_LOS )

    If ( !can_cast( caster, circle ) )
    Return 0;
    Endif

    Var cx := caster.x;
    Var cy := caster.y;
    Var shp := GetHp( caster );

    Var cast_on := Target( caster, targopt );
    
    If( !cast_on  || !GetStrength( cast_on ) )
    EraseObjProperty( caster, "#Casting" );
    Return 0;
    Endif
 
    If( cast_on.hidden )
    SendSysMessage( caster, "You can't see that." );
    EraseObjProperty( caster, "#Casting" );
    Return 0;
    Endif

    If ( (cx != caster.x) || (cy != caster.y) || (shp > GetHp(caster)) )
    SendSysMessage( caster, ERROR_MSG_LOST_CONCENTRATION );
    EraseObjProperty( caster, "#Casting" );
    Return 0;
    Endif

    Return cast_on;

Endfunction


Function CanTargetThing( caster, circle := 1, targopt := TGTOPT_CHECK_LOS )

    If( !can_cast( caster, circle ) )
    Return 0;
    Endif

    Var cx := caster.x;
    Var cy := caster.y;
    Var shp := GetHp(caster);

    Var cast_on := Target( caster, targopt );

    If( !cast_on )
    EraseObjProperty( caster, "#Casting" );
    Return 0;
    Endif
    
    If( ( cx != caster.x ) || ( cy != caster.y ) || ( shp > GetHp( caster ) ) )
    SendSysMessage( caster, ERROR_MSG_LOST_CONCENTRATION );
    EraseObjProperty( caster, "#Casting" );
    Return 0;
    Endif

    Return cast_on;

Endfunction


Function CheckForAnotherProtItem( who, item, prot )

    Var prots :=
    {
    "PoisonImmunity",
    "MagicImmunity",
    "SpellReflect"
    };

    If( !( prot in prots ) )
    Return 0;
    Endif

    EraseObjProperty( who, prot );
    Foreach thing in ListEquippedItems( who )
    If( GetObjProperty( thing, prot ) )
    SetObjProperty( who, prot, thing.serial );
    Break;
    Endif
    Endforeach

    Return 1;

Endfunction


Function ExtractName( name )

	Var words := SplitWords( name );

	//Trunc the articles
	if( (words[1] == "A") || (words[1] == "a") || (words[1] == "An") || (words[1] == "an") )
		name := words[2];
		Var i := 3;
		for( i; i <= len(words); i := i + 1 )
			name := name + " " + words[i];
		endfor
	Endif


	//Remove the "corpse of" from the name
	words := SplitWords( name );
	if( (words[1] == "corpse") && (words[2] == "of") )
		name := words[3];
		Var i := 4;
		if( words[3] == "a" )
			name := words[4];
			i := 5;
		Endif

		for( i; i <= len(words); i := i + 1)
			name := name + " " + words[i];
		endfor
	Endif


	//Remove the "Reanimated" or "conjured" from the name
	words := SplitWords( name );
	if( (words[1] == "Reanimated") || (words[1] == "conjured") )
		name := words[2];
		Var i := 3;
		for( i; i <= len(words); i := i + 1 )
			name := name + " " + words[i];
		endfor
	Endif

	if( !name )
		name := "creature";
	Endif

	return name;

Endfunction


Function FindOption( options, wanted )

	if( options[wanted] )
		return 1;
	else
		return 0;
	Endif

Endfunction


Function GetCircle( spell )

    Var conf   	:= ReadConfigFile( ":*:spells" );
    Var elem   	:= FindConfigElem( conf, spell );
    Var circ 	:= GetConfigString( elem, "Circle" );
    
    conf		:= ReadConfigFile( ":*:circles" );
    
    Var circle	:= conf[circ].UseCircle;
    If (!circle)
    circle 	:= circ;
    Endif
    
    Return CInt( circle );

Endfunction


Function GetMagicEfficiencyPenalty( who )

    Var penalty := 0;

    If( Who.IsA( POLCLASS_NPC ) )
    Return 0;
    Endif

    Foreach item in ListEquippedItems( who )
    If( GetObjProperty( item, "MagicPenalty" ) )
    penalty := penalty + GetObjProperty( item, "MagicPenalty" );
    Endif
    Endforeach

    If( penalty > 100 )
    penalty := 100;
    Endif

    Return CInt( penalty );

Endfunction


Function GetProtLevel( cast_on, element )

    Var prot;

    Case( element )
    FIRE:
    prot := GetObjProperty( cast_on, "FireProtection" );
    Break;
    AIR:
    prot := GetObjProperty( cast_on, "AirProtection" );
    Break;
    EARTH:
    prot := GetObjProperty( cast_on, "EarthProtection" );
    Break;
    WATER:
    prot := GetObjProperty( cast_on, "WaterProtection" );
    Break;
    NECRO:
    prot := GetObjProperty( cast_on, "NecroProtection" );
    Break;
    HOLY:
    prot := GetObjProperty( cast_on, "HolyProtection" );
    Break;
    default:
    Endcase

    If( !prot )
    prot := 0;
    Endif

    Return prot;

Endfunction


Function GetResultingElementalProt( cast_on, element )

    Var complementary;
    Var opposed;
 
    Case( element )
    FIRE:
    complementary 	:= WATER;
    opposed		:= AIR;
    Break;
    AIR:
    complementary 	:= FIRE;
    opposed		:= EARTH;
    Break;
    EARTH:
    complementary 	:= AIR;
    opposed		:= WATER;
    Break;
    WATER:
    complementary 	:= EARTH;
    opposed		:= FIRE;
    Break;
    Endcase

    Var eprot := GetProtLevel( cast_on, element );
    Var cprot := GetProtLevel( cast_on, complementary );
    Var oprot := GetProtLevel( cast_on, opposed );

    If( oprot < 0 )
    oprot := 6 - oprot;
    Endif

    Var resultprot := eprot + CInt( cprot / 2 ) -  CInt( oprot / 2 );

    Return resultprot;

Endfunction


Function GetResultingPlaneProtection( cast_on, plane )

    Var opposed;
    
    If( plane == NECRO )
    opposed := HOLY;
    Elseif( plane == HOLY )
    opposed := NECRO;
    Else
    Return 0;
    Endif

    Var planeprot := GetProtLevel( cast_on, plane );
    Var opposedprot := GetProtLevel( cast_on, opposed );

    If( opposedprot < 0 )
    opposedprot := 6 - opposedprot;
    Endif

    Var resultingprot := planeprot - opposedprot;

    Return resultingprot;

Endfunction


Function GetScript( spellid )

    Var spellcfg := ReadConfigFile( ":*:spells" );
    Var script := spellcfg[spellid].Script;
    
    If( spellid <= MAX_NORMAL_SPELL )
    script := ":spells:" + script;
    Elseif( spellid <= MAX_NECRO_SPELL )
    script := ":necro:" + script;
    Elseif( spellid <= MAX_EARTH_SPELL )
    script := ":earth:" + script;
    Elseif( spellid <= MAX_RITUAL_SPELL )
    script := ":artificier:" + script;
    Endif

    return script;

Endfunction


Function IsProtected( caster, cast_on, circle )

    Var protserial := GetObjProperty( cast_on, "MagicImmunity" );
    Var protlvl	 := Cint(GetObjProperty( cast_on, "PermMagicImmunity" ));
    
    If( !protlvl )
    protlvl := 0;
    Endif

    circle := circle * ClasseBonus( cast_on, CLASSEID_WARRIOR );

    Var cmi := 0 - protlvl;
    Var item;
    Var charges;
    Var cursed;

    If( protserial )
    Foreach thing in ListEquippedItems( cast_on )
      If( thing.serial == protserial )
      item := thing;
      charges := CInt( GetObjProperty( item, "MagicImmunity" ) );
      cursed := GetObjProperty( item, "Cursed" );
        If( !charges )
        EraseObjProperty( cast_on, "MagicImmunity" );
        EraseObjProperty( item, "MagicImmunity" );
        PrintTextAbovePrivate(item, CStr(item.desc + " is out of charges!"), cast_on );
        CheckForAnotherProtItem( cast_on, item, "MagicImmunity" );
        Endif
      Break;
      Endif
    Endforeach
    Endif

    If( charges >= circle )
    charges := charges - circle;
    SetObjProperty( item, "MagicImmunity", charges );
      If( !cursed )
      PrintTextAbovePrivate( cast_on, "Your " + item.desc + " protected you from the spell!", cast_on );
      Return IMMUNED;
      Else
      Return CURSED;
      Endif
    Elseif( cmi >= circle )
    Return CURSED;
    Elseif( protlvl >= circle )
    PrintTextAbovePrivate( cast_on, caster.name + "'s spell is absorbed by your magical protection!", cast_on );
    PrintTextAbovePrivate( cast_on, "The spell dissipates upon contact with " + cast_on.name + "'s magical barrier!", caster );
    Return IMMUNED;
    Endif

    Return 0;

Endfunction


Function ModifyWithMagicEfficiency( who, val )

    If( GetObjProperty( who, CLASSEID_MAGE ) )
    val := CInt( val * ClasseBonus( who, CLASSEID_MAGE ) );
    Elseif( GetObjProperty( who, CLASSEID_WARRIOR ) )
    val := CInt( val / ClasseBonus( who, CLASSEID_WARRIOR ) );
    Endif

    Var penalty := CInt( GetMagicEfficiencyPenalty( who ) );
    
    If( penalty >= 100 )
    Return 0;
    Endif

    Return CInt( val * ( 100 - penalty ) / 100 );

Endfunction


Function PolymorphMobile( cast_on, new_form, new_color, duration, mod := 0 )

    Var parms := {};
    parms[1] := cast_on;
    parms[2] := CInt( new_form );
    parms[3] := CInt( new_color );
    parms[4] := CInt( duration );
    
    If( mod )
    parms[5] := mod;
    Endif

    Start_Script( ":summoning:polymorphing", parms );

Endfunction


Function Reflect( source, targ )

    If( source.dead )
    Return;
    Endif
    
    If( targ.dead )
    Return;
    Endif

    PlaySoundEffect( source, SFX_SPELL_MAGIC_REFLECTION );
    PlayObjectCenteredEffect( source, FX_SPELL_MAGIC_REFLECTION, SPEED_SPELL_MAGIC_REFLECTION, LOOP_SPELL_MAGIC_REFLECTION );
    SendSysMessage( source, "Your magic reflect spell saved you!" );
    
    If( SPELL_EFFECT_TYPE_MOVING == 1 )
    sleep( 1 );
    PlayMovingEffect(
    source,
    targ,
    SPELL_EFFECT_ID,
    SPELL_EFFECT_SPEED,
    SPELL_EFFECT_LOOP,
    explode := 0
    );
    Endif

Endfunction


Function Reflected( caster, cast_on, circle )

    Var source	:= caster;
    Var targ	:= cast_on;
    Var wasreflected;

    if( SPELL_EFFECT_TYPE_MOVING == 1 )
    PlayMovingEffect(
    source,
    targ,
    SPELL_EFFECT_ID,
    SPELL_EFFECT_SPEED,
    SPELL_EFFECT_LOOP,
    explode := 0
    );
    Endif
    
    If( source == targ )
      Case( SPELL_EFFECT_TYPE_MOVING )
      2:
      PlayLightningBoltEffect( targ );
      PlaySoundEffect( targ, SFX_SPELL_LIGHTNING );
      Break;
      3:
      PlayLightningBoltEffect( targ );
      PlaySoundEffect( targ, SFX_SPELL_CALL_LIGHTNING );
      PlayLightningBoltEffect( targ );
      PlaySoundEffect( targ, SFX_SPELL_CALL_LIGHTNING );
      Break;
      4:
      PlayStationaryEffect( targ.x, targ.y, targ.z, SPELL_EFFECT_ID, SPELL_EFFECT_SPEED, SPELL_EFFECT_LOOP );
      Break;
      default:
      PlayObjectCenteredEffect(
      targ,
      SPELL_EFFECT_ID,
      SPELL_EFFECT_SPEED,
      SPELL_EFFECT_LOOP
      );
      Break;
      Endcase
    Return targ;
    Endif

/*
 ---- Old ----
    If( source == targ )
      If( !SPELL_EFFECT_TYPE_MOVING && SPELL_EFFECT_ID )
      PlayObjectCenteredEffect(
      targ,
      SPELL_EFFECT_ID,
      SPELL_EFFECT_SPEED,
      SPELL_EFFECT_LOOP
      );
      Elseif( SPELL_EFFECT_TYPE_MOVING == 2 )
      PlayLightningBoltEffect( targ );
      PlaySoundEffect( targ, SFX_SPELL_LIGHTNING );
      Elseif( SPELL_EFFECT_TYPE_MOVING == 3 )
      PlayLightningBoltEffect( targ );
      PlaySoundEffect( targ, SFX_SPELL_CALL_LIGHTNING );
      PlayLightningBoltEffect( targ );
      PlaySoundEffect( targ, SFX_SPELL_CALL_LIGHTNING );
      Elseif( SPELL_EFFECT_TYPE_MOVING == 4 )
      PlayStationaryEffect( targ.x, targ.y, targ.z, SPELL_EFFECT_ID, SPELL_EFFECT_SPEED, SPELL_EFFECT_LOOP );
      Endif
    Return targ;
    Endif
 ---- Old ----
*/

    Var permmr   := CInt( GetObjProperty( targ, "Permmr" ) );
    Var corrupmr := CInt( 0 - permmr );
    Var protserial := CInt( GetObjProperty( targ, "SpellReflect") );
    Var item;
    Var cursed;
    Var charges;
    
    If( protserial )
    Set_Critical( 1 );
    Foreach thing in ListEquippedItems( targ )
      If( thing.serial == protserial )
      item := thing;
      cursed  := GetObjProperty( item, "Cursed" );
      charges := CInt( GetObjProperty( item, "SpellReflect" ) );
        If( !charges )
        EraseObjProperty( item, "SpellReflect" );
        EraseObjProperty( targ, "SpellReflect" );
        PrintTextAbovePrivate( item, item.desc + " is out of charges!", targ );
        CheckForAnotherProtItem( targ, item, "SpellReflect" );
        Endif
      Break;
      Endif
    Endforeach
    Set_Critical( 0 );
    Endif


    If( charges && charges >= circle )
    charges := CInt( charges - circle );
    SetObjProperty( item, "SpellReflect", charges );
      If( !cursed )
      PrintTextAbovePrivate( targ, "Your " + item.desc + " reflected the spell!", targ );
      source := cast_on;
      targ := caster;
      Reflect( source, targ );
      Else
      PrintTextAbovePrivate( targ, "Your " + item.desc + " prevent all reflections!", targ );
      Endif
    Elseif( corrupmr >= circle )
    PrintTextAbovePrivate( targ, "One of your item prevent all reflections!", targ );
    Elseif( CInt(GetObjProperty( targ, "mr" )) >= circle )
    EraseObjProperty(targ, "mr");
    source := cast_on;
    targ := caster;
    Reflect( source, targ );
    Elseif( permmr >= circle )
    source := cast_on;
    targ := caster;
    Reflect( source, targ );
    Endif

    If( targ == caster )
    SendSysMessage( caster, "The spell is reflected back to you!" );
    Endif

    Case( SPELL_EFFECT_TYPE_MOVING )
    2:
    PlayLightningBoltEffect( targ );
    PlaySoundEffect( targ, SFX_SPELL_LIGHTNING );
    Break;
    3:
    PlayLightningBoltEffect( targ );
    PlaySoundEffect( targ, SFX_SPELL_CALL_LIGHTNING );
    PlayLightningBoltEffect( targ );
    PlaySoundEffect( targ, SFX_SPELL_CALL_LIGHTNING );
    Break;
    4:
    PlayStationaryEffect( targ.x, targ.y, targ.z, SPELL_EFFECT_ID, SPELL_EFFECT_SPEED, SPELL_EFFECT_LOOP );
    Break;
    default:
    PlayObjectCenteredEffect(
    targ,
    SPELL_EFFECT_ID,
    SPELL_EFFECT_SPEED,
    SPELL_EFFECT_LOOP
    );
    Break;
    Endcase

    Return targ;

Endfunction


Function Resisted( caster, cast_on, circle, dmg )

	if( cast_on.dead ) return 0; Endif
	if(caster.dead) return 0; Endif

	Var multiplier;
	Var points 	:= circle * 40;
	Var magery 	:= GetAttribute( caster, ATTRIBUTEID_MAGERY );
	Var evalint 	:= GetAttribute( caster, ATTRIBUTEID_EVALINT );
	Var resist 	:= GetAttribute( cast_on, ATTRIBUTEID_MAGICRESISTANCE );
	Var chance 	:= CInt( resist / 6);
	Var chance2 	:= CInt( resist - ((magery / 4) + (circle * 6)) );

	if( chance2 > chance )
		chance := chance2;
	Endif

	if( GetObjProperty( cast_on, CLASSEID_MAGE ) )
		chance := CInt( chance * ClasseBonus( cast_on, CLASSEID_MAGE ) );
	Elseif( GetObjProperty( cast_on, CLASSEID_WARRIOR ) )
		Var bonus := ClasseBonus( cast_on, CLASSEID_WARRIOR );
		chance := CInt( chance / bonus / 2 );
		resist := CInt( resist / bonus );
	Endif

	if( GetObjProperty( caster, CLASSEID_MAGE ) )
		chance := CInt( chance / ClasseBonus( caster, CLASSEID_MAGE ) );
	Elseif( GetObjProperty( caster, CLASSEID_WARRIOR ) )
		Var bonus := ClasseBonus( caster, CLASSEID_WARRIOR );
		chance := CInt( chance * bonus * 2 );
		resist := CInt( resist * bonus );
	Endif

	if( resist < 25 )
		AwardPoints( cast_on, SKILLID_MAGICRESISTANCE, MISC_SKILL_POINTS );
	Endif

	if( random(100)+1 <= chance )
		SendSysMessage( cast_on, "You feel yourself resisting magical energy!" );
		PlaySoundEffect( cast_on, SFX_SPELL_WEAKEN );
		PlayObjectCenteredEffect( cast_on, FX_SPELL_CURSE, 5, 5 );
		dmg := CInt( dmg / 2 );
		if( dmg < 1 )
			dmg := 1;
		Endif
	
		if( !caster.multi && !cast_on.multi )
			AwardPoints( cast_on, SKILLID_MAGICRESISTANCE, MISC_SKILL_POINTS );
		Endif
	Endif

	dmg := CInt( dmg * (1 + (evalint - resist) / 200) );

	if( GetObjProperty( cast_on, CLASSEID_MAGE ) )
		dmg := CInt( dmg / ClasseBonus( cast_on, CLASSEID_MAGE ) );
	Elseif( GetObjProperty( cast_on, CLASSEID_WARRIOR ) )
		dmg := CInt( dmg * ClasseBonus( cast_on, CLASSEID_WARRIOR ) );
	Endif

	if( dmg < 0 )
		dmg := 0;
	Endif

	return dmg;

Endfunction


Function ResistedDefinedSkillGain( caster, cast_on, dmg, diff, points := 0 )

	if( cast_on.dead ) return 0; Endif
	if(caster.dead) return 0; Endif

	Var evalint;
	if( caster )
		evalint := GetAttribute( caster, ATTRIBUTEID_EVALINT );
	Endif

	if( !evalint )
		evalint := 0;
	Endif

	Var resist	:= GetAttribute( cast_on, ATTRIBUTEID_MAGICRESISTANCE );

	if( CheckSkill( cast_on, SKILLID_MAGICRESISTANCE, diff, COMBAT_SKILL_POINTS ) )
		dmg := CInt( dmg / 2 );
		if( dmg < 1 )
			dmg := 1;
		Endif
	Endif

	dmg := CInt( dmg * (1 + (evalint - resist) / 200) );

	if( GetObjProperty( cast_on, CLASSEID_MAGE ) )
		dmg := CInt( dmg / ClasseBonus( cast_on, CLASSEID_MAGE ) );
	Elseif( GetObjProperty( cast_on, CLASSEID_WARRIOR ) )
		dmg := CInt( dmg * ClasseBonus( cast_on, CLASSEID_WARRIOR ) );
	Endif

	if( dmg < 0 )
		dmg := 0;
	Endif

	return dmg;

Endfunction


Function Send_Attack( ttarget, source, spellid := 0 )

	Var ev := array;
	ev.+type;
	ev.+source;

	ev.type := SYSEVENT_ENGAGED;
	ev.source := source;
	SendEvent( ttarget, ev );

 	if (spellid)
         	ev.+spell;
         	ev.+type := 0x0800; //spell attack
         	ev.+spell := spellid;
         	SendEvent(ttarget, ev);
 	Endif

Endfunction


Function SummonCreature( caster, npctemplate, cast_loc, sfx := 0x0218, delay := 0 )

	Var parms := {};

	parms[1] := caster;
	parms[2] := npctemplate;
	parms[3] := cast_loc;
	parms[4] := sfx;
	parms[5] := delay;

	start_script( ":summoning:summoning", parms );

Endfunction


Function TruncPkgName( name )

	if( name[1] == ":" )
		Var i;
		for( i := 2; i <= len(name); i := i + 1 )
			if( name[i] == ":" )
				break;
			Endif
		endfor

		return name[i+1,len(name)];

	else
		return name;
	Endif

Endfunction


Function TryToCast( caster, spell, anim := ANIM_CAST_DIR )

	//Variables declaration and initialisation
	Var conf := ReadConfigFile( ":*:spells" );
	Var elem := FindConfigElem( conf, spell );
	Var circ := GetConfigInt( elem, "Circle" );
	conf := ReadConfigFile( ":*:circles" );
	Var spelldelay := CInt( conf[circ].Delay );
	Var value := CInt( conf[circ].PointValue );
	Var manacost := CInt( conf[circ].Mana );
	Var difficulty := CInt( conf[circ].Difficulty );

	//Casting Options management
	Var options := GetObjProperty( caster, CASTINGOPT_PROP_NAME );
	If( !options )
	options := GetObjProperty( caster, PERM_CASTINGOPT_PROP_NAME );
		If( !options )
		options := "";
		Endif
	Else
	EraseObjProperty( caster, CASTINGOPT_PROP_NAME );
	Endif

	//Try to cast the spell
    PerformAction( caster, anim );

	//Speak the power words
	If ( !FindOption( options, CASTINGOPT_NO_WORDS ) )
    SpeakPowerWords( caster, spell );
	Endif

    If( IsInAntiMagicArea( caster ) )
    FailSpell( Caster, ERROR_MSG_ANTI_MAGIC_AREA );
    Return IN_ANTIMAGIC_AREA;
    Endif

	//Check for the equipment in hands
	If( !FindOption( options, CASTINGOPT_ANY_EQUIPMENT ) )
		Var hand1	:= GetEquipmentByLayer( caster, LAYER_HAND1 );
		Var hand2	:= GetEquipmentByLayer( caster, LAYER_HAND2 );
		If( hand1 || hand2 )
			Var weapcfg := ReadConfigFile( ":*:itemdesc" );
			If( hand1 && weapcfg[hand1.objtype].BlocksCastingIfInHand != 0 )
			FailSpell( Caster, ERROR_MSG_WRONG_EQUIPMENT );
			Return INVALID_EQUIPMENT;
			Endif
			If( hand2 && weapcfg[hand2.objtype].BlocksCastingIfInHand != 0)
			SendSysMessage( caster, ERROR_MSG_WRONG_EQUIPMENT );
			FailSpell( Caster, ERROR_MSG_WRONG_EQUIPMENT );
			Return INVALID_EQUIPMENT;
			Endif
		Endif
	Endif

	//Consume the reagents
	If( !FindOption( options, CASTINGOPT_NO_REAGENTS ) )
        If( !ConsumeReagents( caster, spell ) )
		FailSpell( Caster, ERROR_MSG_NOT_ENOUGH_REAGENTS );
		Return NO_REGS;
		Endif
	Endif

	//Consume the mana
	If( !FindOption( options, CASTINGOPT_NO_MANA ) )
        If( !ConsumeMana( caster, spell ) )
		FailSpell( Caster, ERROR_MSG_NOT_ENOUGH_MANA );
		Return NO_MANA;
		Endif
	Endif

	//Check for the equipment in hands -- MOVED, This is the old spot; Unreal.

	//Delay and interruption management
	If( !FindOption( options, CASTINGOPT_NO_DELAY ) )
		Var shp := GetHp(caster);
/*
		Var sx := caster.x;
		Var sy := caster.y;
		Var sz := caster.z;
*/

		//True mages cast faster
		If( GetObjProperty( caster, CLASSEID_MAGE ) )
		spelldelay := CInt( spelldelay / ClasseBonus( caster, CLASSEID_MAGE ) );
		Elseif( GetObjProperty( caster, CLASSEID_WARRIOR ) )
		spelldelay := CInt( spelldelay * ClasseBonus( caster, CLASSEID_WARRIOR ) );
		Endif

		While( spelldelay >= 500 )
		SleepMS( 500 );
		spelldelay := spelldelay - 500;
			If( GetHp( caster ) < shp )
			FailSpell( Caster, ERROR_MSG_INTERRUPTED );
			Return INTERRUPTED;
			Endif
/*
			If( caster.x != sx || caster.y != sy || caster.z != sz )
				SendSysMessage( caster, ERROR_MSG_LOST_CONCENTRATION );
				PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
				PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
				return INTERRUPTED;
			Endif
*/
		Endwhile

		SleepMS( spelldelay );

		If( GetHp( caster ) < shp )
		FailSpell( Caster, ERROR_MSG_INTERRUPTED );
		Return INTERRUPTED;
		Endif
/*
		If( caster.x != sx || caster.y != sy || caster.z != sz )
			SendSysMessage( caster, ERROR_MSG_LOST_CONCENTRATION );
			PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
			PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
			return INTERRUPTED;
		Endif
*/
	Endif

	//Consume the reagents -- MOVED, This is the old spot; Unreal.

	//Consume the mana -- MOVED, This is the old spot; Unreal.

	//Do the skill check and return mana if failure occur
	If( !FindOption( options, CASTINGOPT_NO_SKILL_CHECK ) )
        If( !CheckSkill( caster, SKILLID_MAGERY, difficulty, ACTION_SKILL_POINTS ) )
		SetMana( caster, GetMana( caster ) + manacost );
			If( GetMana( caster ) > GetMaxMana( caster ) )
			SetMana( caster, GetMaxMana( caster ) );
			Endif
        FailSpell( Caster, ERROR_MSG_FIZZLE );
		Return NO_SKILL;
		Endif
	Endif

	Return SUCCESS;

Endfunction

Function FailSpell( Caster, Message )

    PlayObjectCenteredEffect( Caster, FX_SPELL_FIZZLE, 1, 35 );
    PlaySoundEffect( Caster, SFX_SPELL_FIZZLE );
    SendSysMessage( Caster, Message );
    Return 1;

Endfunction
