/*
   Author: Unreal (MontuZ@Gmail.com) Nov 12, 2004.
   Version: 1.0
   Core: 095
   PS: You know it was done by me when it's so clean.
*/

Use datafile;

Function FindEmail( Email )

    Email := Lower( Email );

    Var Email_DataFile := OpenDataFile( "Emails" );
    If( !Email_DataFile )
    Email_DataFile := CreateDataFile( "Emails", DF_KEYTYPE_STRING );
    Endif

    Var Stored_Emails := Email_DataFile.FindElement( "Email" );
    If( !Stored_Emails )
    Stored_Emails := Email_DataFile.CreateElement( "Email" );
    Endif

    Var UsedEmail := Stored_Emails.GetProp( Email );
    If( UsedEmail )
    Return 1;
    Else
    Return 0;
    Endif

Endfunction

Function FindIP( IP )

    IP := Lower( IP );

    Var IP_DataFile := OpenDataFile( "IPs" );
    If( !IP_DataFile )
    IP_DataFile := CreateDataFile( "IPs", DF_KEYTYPE_STRING );
    Endif

    Var Stored_IPs := IP_DataFile.FindElement( "IP" );
    If( !Stored_IPs )
    Stored_IPs := IP_DataFile.CreateElement( "IP" );
    Endif

    Var UsedIP := Stored_IPs.GetProp( IP );
    If( UsedIP )
    Return 1;
    Else
    Return 0;
    Endif

Endfunction

Function SetIP( IP )

    IP := Lower( IP );

    Var IP_DataFile := OpenDataFile( "IPs" );
    If( !IP_DataFile )
    IP_DataFile := CreateDataFile( "IPs", DF_KEYTYPE_STRING );
    Endif

    Var Stored_IPs := IP_DataFile.FindElement( "IP" );
    If( !Stored_IPs )
    Stored_IPs := IP_DataFile.CreateElement( "IP" );
    Endif

    Var UsedIP := Stored_IPs.GetProp( IP );
    If( UsedIP )
    Return 1;
    Else
    Stored_IPs.SetProp( IP, "Active" );
    Return 1;
    Endif

Endfunction

Function SetEmail( Email )

    Email := Lower( Email );

    Var Email_DataFile := OpenDataFile( "Emails" );
    If( !Email_DataFile )
    Email_DataFile := CreateDataFile( "Emails", DF_KEYTYPE_STRING );
    Endif

    Var Stored_Emails := Email_DataFile.FindElement( "Email" );
    If( !Stored_Emails )
    Stored_Emails := Email_DataFile.CreateElement( "Email" );
    Endif

    Var UsedEmail := Stored_Emails.GetProp( Email );
    If( UsedEmail )
    Return 1;
    Else
    Stored_Emails.SetProp( Email, "Active" );
    Return 0;
    Endif

Endfunction

Function FindSession( SessionID )

    Var Session_DataFile := OpenDataFile( "SessionIDs" );
    If( !Session_DataFile )
    Session_DataFile := CreateDataFile( "SessionIDs", DF_KEYTYPE_STRING );
    Endif

    Var Stored_Sessions := Session_DataFile.FindElement( "Session" );
    If( !Stored_Sessions )
    Stored_Sessions := Session_DataFile.CreateElement( "Session" );
    Endif

    Var Session := Stored_Sessions.GetProp( SessionID );
    If( Session )
    Return Session;
    Else
    Return "Session ID was not found.";
    Endif

Endfunction

Function EndSession( SessionID )

    Var Session_DataFile := OpenDataFile( "SessionIDs" );
    If( !Session_DataFile )
    Session_DataFile := CreateDataFile( "SessionIDs", DF_KEYTYPE_STRING );
    Endif

    Var Stored_Sessions := Session_DataFile.FindElement( "Session" );
    If( !Stored_Sessions )
    Stored_Sessions := Session_DataFile.CreateElement( "Session" );
    Endif

    Var Session := Stored_Sessions.GetProp( SessionID );
    If( Session )
    Stored_Sessions.EraseProp( SessionID );
    Else
    Return 0;
    Endif

Endfunction

Function SetSession( Accnt, Pass, Email, AccntIP )

    Var SessionID := GenerateSessionID();

    Var Session_DataFile := OpenDataFile( "SessionIDs" );
    If( !Session_DataFile )
    Session_DataFile := CreateDataFile( "SessionIDs", DF_KEYTYPE_STRING );
    Endif

    Var Stored_Sessions := Session_DataFile.FindElement( "Session" );
    If( !Stored_Sessions )
    Stored_Sessions := Session_DataFile.CreateElement( "Session" );
    Endif

    Var Session := Stored_Sessions.GetProp( SessionID );
    
    If( Session )
    Session := Array;
    Session.Append( Accnt );
    Session.Append( Pass );
    Session.Append( Email );
    Session.Append( AccntIP );
    Stored_Sessions.EraseProp( SessionID );
    Stored_Sessions.SetProp( SessionID, Session );
    Return ( SessionID );
    Else
    Session := Array;
    Session.Append( Accnt );
    Session.Append( Pass );
    Session.Append( Email );
    Session.Append( AccntIP );
    Stored_Sessions.SetProp( SessionID, Session );
    Return ( SessionID );
    Endif

Endfunction

Function GenerateSessionID()

    Var Alpha := {
    "A","B","C","D","E",
    "F","G","H","I","J",
    "K","L","M","N","O",
    "P","Q","R","S","T",
    "U","V","W","X","Y",
    "Z"
    };

    Var SessionID := "";
    Var Counter := 15;

    While( Counter )
    SessionID := SessionID + Alpha[ RandomInt( Len( Alpha ) ) + 1];
    Counter := Counter - 1;
    Endwhile

    Return SessionID;

Endfunction

Function SetLostPasswordSession( Accnt )

    Var SessionID := GenerateSessionID();
    Var NewPassword := GenerateNewPassword();

    Var Session_DataFile := OpenDataFile( "LostPasswordSessionIDs" );
    If( !Session_DataFile )
    Session_DataFile := CreateDataFile( "LostPasswordSessionIDs", DF_KEYTYPE_STRING );
    Endif

    Var Stored_Sessions := Session_DataFile.FindElement( "LostPasswordSession" );
    If( !Stored_Sessions )
    Stored_Sessions := Session_DataFile.CreateElement( "LostPasswordSession" );
    Endif

    Var Session := Stored_Sessions.GetProp( SessionID );

    If( Session )
    Session := Array;
    Session.Append( Accnt );
    Session.Append( NewPassword );
    Stored_Sessions.EraseProp( SessionID );
    Stored_Sessions.SetProp( SessionID, Session );
    Return ( SessionID );
    Else
    Session := Array;
    Session.Append( Accnt );
    Session.Append( NewPassword );
    Stored_Sessions.SetProp( SessionID, Session );
    Return ( SessionID );
    Endif

Endfunction

Function FindLostPasswordSession( SessionID )

    Var Session_DataFile := OpenDataFile( "LostPasswordSessionIDs" );
    If( !Session_DataFile )
    Session_DataFile := CreateDataFile( "LostPasswordSessionIDs", DF_KEYTYPE_STRING );
    Endif

    Var Stored_Sessions := Session_DataFile.FindElement( "LostPasswordSession" );
    If( !Stored_Sessions )
    Stored_Sessions := Session_DataFile.CreateElement( "LostPasswordSession" );
    Endif

    Var Session := Stored_Sessions.GetProp( SessionID );
    If( Session )
    Return Session;
    Else
    Return 0;
    Endif

Endfunction

Function EndLostPasswordSession( SessionID )

    Var Session_DataFile := OpenDataFile( "LostPasswordSessionIDs" );
    If( !Session_DataFile )
    Session_DataFile := CreateDataFile( "LostPasswordSessionIDs", DF_KEYTYPE_STRING );
    Endif

    Var Stored_Sessions := Session_DataFile.FindElement( "LostPasswordSession" );
    If( !Stored_Sessions )
    Stored_Sessions := Session_DataFile.CreateElement( "LostPasswordSession" );
    Endif

    Var Session := Stored_Sessions.GetProp( SessionID );
    If( Session )
    Stored_Sessions.EraseProp( SessionID );
    Else
    Return 0;
    Endif

Endfunction

Function GenerateNewPassword()

    Var Alpha := {
    "A","B","C","D","E",
    "F","G","H","I","J",
    "K","L","M","N","O",
    "P","Q","R","S","T",
    "U","V","W","X","Y",
    "Z","1","2","3","4",
    "5","6","7","8","9"
    };

    Var NewPassword := "";
    Var Counter := 10;

    While( Counter )
    NewPassword := NewPassword + Alpha[ RandomInt( Len( Alpha ) ) + 1];
    Counter := Counter - 1;
    Endwhile

    Return NewPassword;

Endfunction
