////////////////////////////////////////////////////////////////
//
//	CONSTANTS
//
////////////////////////////////////////////////////////////////
//  Updated: Unreal (MontuZ@Gmail.com)
//  If you want overall better loot from monsters.
//  Set MAGIC_LEVELMULTI above 1.0. Example, 1.25.
//  If you want lower loot from monsters.
//  Set MAGIC_LEVELMULTI below 1.0. Example, 0.75.
//  Same goes for MAGIC_CHANCEMULTI. If you want more of a chance to get magic items, set it above
//  1.0.
//
//  HIT/STAM/MANA is NOT used anymore to determain a NPC's max life/mana/stam.
//  NPC_STAT_MULTIPLIER * Npc's Str/Int/Dex == Max Life/Mana/Stam.
//
//  I added this to make it easier for us all. So we don't have to go through the npcdesc.cfg
//  and set all the levels to what we want.
//
//  1.0 is like 100% normal; so 1.25 is 125% (+25% more than normal)
//
//  NOTE: Default Setting for ALL of these Consts is 1.0;
//  Don't forget if you change these you'll need to compile everything.
//
// Start - These consts make a big differance in-game!
const MAGIC_LEVELMULTI         := 0.8;    // For better magic items raise this by + 0.25/0.5/1.0, etc.
const MAGIC_CHANCEMULTI        := 0.8;    // For better chance at magic items raise this by + Above.
const SKILLGAIN_MULTI          := 1.0;    // For faster skillgain raise this by + Above.
const STATGAIN_MULTI           := 1.5;    // For faster statgain raise this by + Above.
const NPC_VITAL_MULTIPLIER     := 5.0;    // For monsters with more HP/SP/MP raise this by + Above.
const PC_VITAL_MULTIPLIER      := 1.0;    // For players with more HP/SP/MP raise this by + Above.
const SKILL_STAT_CAP           := 150;    // What's the skill/stat cap?
const DISPLAY_DAMAGE_OVER_HEAD := 0;      // 1 to enable 0 to disable?
const LORE_SKILL_POINTS        := 300;
const ACTION_SKILL_POINTS      := 300;
const COMBAT_SKILL_POINTS      := 300;
const MISC_SKILL_POINTS        := 400;
// End