//
// bank.inc: var bankbox functions
//
// public functions:
//   FindBankBox( character)      returns World Bank bankbox for a character
//   WipeBankBox( character )     does what you might think.
//   OpenWorldBank()              returns handle to World Bank.
//

use os;

include "include/objtype";

function FindBankBox( character )

  var worldbank := OpenWorldBank();
  var bank_obj_name := "Bankbox of " + CInt( character.serial );
  var bankbox := FindRootItemInStorageArea( worldbank, bank_obj_name );
  if (!bankbox)
    bankbox := CreateRootItemInStorageArea( worldbank, bank_obj_name, UOBJ_BANKBOX );
  endif
  if(!bankbox)
    syslog( "Unable to find or create bankbox for " + character.serial );
  endif
  return bankbox;

endfunction

Function WipeBankBox( character )

  Var worldbank := OpenWorldBank();
  Var bank_obj_name := "Bankbox of " + CInt( character.serial );
  
  Return DestroyRootItemInStorageArea( worldbank, bank_obj_name );

Endfunction

Function OpenWorldBank()

  Var bank := FindStorageArea( "World Bank" );
  
  If( !bank )
  bank := CreateStorageArea( "World Bank" );
  Endif
  
  If( !bank )
  syslog( "Unable to open or create world bank!" );
  Endif
  
  Return bank;

Endfunction
